clear all;
close all


set(0,'defaultAxesFontSize',12.5);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',13);
set(0,'defaultTextFontName','Times');

urate79
full_part_emp79
lookfor79
fullrate = full_part_emp(:,1);
partrate = full_part_emp(:,2);
lookforfull = lookfor(:,1);
lookforpart = lookfor(:,2);


startDate = datenum('01-01-1979');
%endDate = datenum('10-01-2016');
endDate = datenum('10-01-2018');
xData = linspace(startDate,endDate,4*(2019-1979));

start=[datenum('01-01-1980') datenum('07-01-1981') datenum('07-01-1990') datenum('03-01-2001') datenum('07-01-2007')];
finish=[datenum('07-01-1980') datenum('11-01-1982') datenum('03-01-1991') datenum('11-01-2001') datenum('06-01-2009')];
colorstr=[0.8 0.8 0.8];




fig = figure; 
left_color = [0 0 0];
right_color = [0 0 0];
set(fig,'defaultAxesColorOrder',[left_color; right_color]);
yyaxis left
scatter(xData(1),fullrate(1),'white');  hold on
plot(xData,fullrate, 'blue','LineWidth',2.5, 'LineStyle','-'); 
datetick('x','yyyy')
ylim([0.70, 0.82]);
curax=axis;
yy=[curax(3) curax(4) curax(4) curax(3)];

for i=1:length(start);
    x=[start(i) start(i) finish(i) finish(i)];
    ps =  fill(x,yy,colorstr);
    %ps = patch(x,yy,colorstr,'FaceAlpha',0.7,'EdgeColor','none');
    uistack(ps,'bottom')
end;
h = findobj(gca,'Type','line');
set(h,'EraseMode','xor');
h = findobj(gca,'Type','patch');
set(h,'EdgeColor','none');
set(gca, 'Layer', 'top')
axis tight
ax.Color = 'black';
ytickformat('%.2f')
ylabel('Full-time employment rate')
str = {'Full-time', 'employment'};
xa = [0.49 0.52];
ya = [0.82 0.77];
annotation('arrow',xa,ya)
text(xData(57),0.812,str,'FontSize',12,'FontWeight','bold')

yyaxis right
scatter(xData(1),partrate(1),'white');  hold on
plot(xData,partrate, ':r','LineWidth',2.5); 
ylim([0.15, 0.19]);
yticks([0.15 0.16 0.17 0.18 0.19]);
ylabel('Part-time employment rate')
str = {'Part-time','employment'};
xa = [0.48 0.52];
ya = [0.29 0.36];
annotation('arrow',xa,ya)
text(xData(57),0.157,str,'FontSize',12,'FontWeight','bold')
print(['Both_fulltime_parttime.eps'],'-depsc2');





figure 
scatter(xData(1),lookforpart(1),'white');  hold on
plot(xData,lookforpart, ':r','LineWidth',2.5)
hold on
plot(xData,lookforfull,'blue','LineWidth',2.5)
%plot(xData,fullrate, 'blue','LineWidth',2.5); hold on
datetick('x','yyyy')

curax=axis;
yy=[curax(3) curax(4) curax(4) curax(3)];

for i=1:length(start);
    x=[start(i) start(i) finish(i) finish(i)];
    ps =  fill(x,yy,colorstr);
    %ps = patch(x,yy,colorstr,'FaceAlpha',0.7,'EdgeColor','none');
    uistack(ps,'bottom')
end;
h = findobj(gca,'Type','line');
set(h,'EraseMode','xor');
h = findobj(gca,'Type','patch');
set(h,'EdgeColor','none');
set(gca, 'Layer', 'top')
yticks([0 0.02 0.04 0.06 0.08 0.10])
axis tight
ytickformat('%.2f')
xa = [0.44 0.41];
ya = [0.73 0.62];
annotation('arrow',xa,ya)
str = {'looking for','full-time work'};
text(xData(53),0.082,str,'FontSize',12,'FontWeight','bold')
xa = [0.45 0.43];
ya = [0.29 0.23];
annotation('arrow',xa,ya)
str2 = {'looking for','part-time work'};
text(xData(53),0.028,str2,'FontSize',12,'FontWeight','bold')
print(['lookfor.eps'],'-depsc2');

