set more off

clear
set maxvar 32000
local current `"xxx\Margin_adjust_detail"'
cd `current'
capture mkdir decomposition_figure_detail
insheet using output_detail.csv, clear

rename v1 date
rename v2 flowEFTEIP
rename v3 flowEFTEVP
rename v4 flowEFTUFT
rename v5 flowEFTUPT
rename v6 flowEFTNNN

rename v7 flowEIPEFT
rename v8 flowEIPEVP
rename v9 flowEIPUFT
rename v10 flowEIPUPT
rename v11 flowEIPNNN

rename v12 flowEVPEFT
rename v13 flowEVPEIP
rename v14 flowEVPUFT
rename v15 flowEVPUPT
rename v16 flowEVPNNN

rename v17 flowUFTEFT
rename v18 flowUFTEIP
rename v19 flowUFTEVP
rename v20 flowUFTUPT
rename v21 flowUFTNNN

rename v22 flowUPTEFT
rename v23 flowUPTEIP
rename v24 flowUPTEVP
rename v25 flowUPTUFT
rename v26 flowUPTNNN

rename v27 flowNNNEFT
rename v28 flowNNNEIP
rename v29 flowNNNEVP
rename v30 flowNNNUFT
rename v31 flowNNNUPT

rename v32 fracEFT
rename v33 fracEIP
rename v34 fracEVP
rename v35 fracUFT
rename v36 fracUPT
rename v37 fracNNN
gen flowEFTEFT = 1- flowEFTEIP - flowEFTEVP - flowEFTUFT - flowEFTUPT - flowEFTNNN
gen flowEIPEIP = 1- flowEIPEFT - flowEIPEVP	- flowEIPUFT - flowEIPUPT - flowEIPNNN
gen flowEVPEVP = 1- flowEVPEFT - flowEVPEIP - flowEVPUFT - flowEVPUPT - flowEVPNNN
gen flowUFTUFT = 1- flowUFTEFT - flowUFTEIP - flowUFTEVP - flowUFTUPT - flowUFTNNN
gen flowUPTUPT = 1- flowUPTEFT - flowUPTEIP - flowUPTEVP - flowUPTUFT - flowUPTNNN
gen flowNNNNNN = 1- flowNNNEFT - flowNNNEIP - flowNNNEVP - flowNNNUFT - flowNNNUPT

order flowEFTEFT, after(date)
order flowEIPEIP, after(flowEIPEFT)
order flowEVPEVP, after(flowEVPEIP)
order flowUFTUFT, after(flowUFTEVP)
order flowUPTUPT, after(flowUPTUFT)
order flowNNNNNN, after(flowNNNUPT)

sort date
gen all = 1
keep flow* frac* date all
reshape wide flow* frac*, i(all) j(date) 
drop all
local status "EFT EIP EVP UFT UPT NNN" 
local x=199601
*local end=201705
local end=201812
while `x' <= `end'-1  {
	local x1 = `x' + 1 
	if (`x'-12)/100 == int((`x'-12)/100) {
		local x1 = `x' + 89
	}
	foreach from of local status{
		quietly gen dif_`from' = frac`from'`x1'- frac`from'`x'
		foreach to of local status{
			quietly gen flowfrom`from'to`to' = frac`from'`x'*flow`from'`to'`x1'			
		}
	}
	preserve
		gen from = `x'
		gen to   = `x1'
		keep flowfrom* dif_* fracEFT`x' fracEIP`x' fracEVP`x' fracUFT`x' fracUPT`x' fracNNN`x' from to
		order from, first
		order to, after(from)
		foreach st of local status{
			quietly rename frac`st'`x' frac`st'
		}
		if `x'>=199602 {
			append using flowfromto.dta
			sort from
		}
		quietly save flowfromto, replace
	restore
	quietly drop flowfrom* dif_*
	local x = `x1'
}
use flowfromto, clear
foreach from of local status{
	foreach to of local status{
			quietly gen netflowfrom`from'to`to' = flowfrom`from'to`to'-flowfrom`to'to`from'			
	}
}
foreach to of local status{
	egen sum_flow`to' = rowtotal(netflowfromEFTto`to' netflowfromEIPto`to' netflowfromEVPto`to' netflowfromUFTto`to' netflowfromUPTto`to' netflowfromNNNto`to')
	quietly gen error_`to' = dif_`to'-sum_flow`to'
	order sum_flow`to', after(dif_`to')
	order error_`to', after(sum_flow`to')
}

quietly{
	gen str4 year=substr(string(to),1,4)
	gen str2 month=substr(string(to),5,6)
	gen year_n = real(year)
	gen month_n = real(month)
	gen survey = ym(year_n, month_n)
	order survey, after(from)
	tsset survey, monthly
	drop year month year_n month_n
	save decomposition.dta, replace
	order dif_EFT, after(survey)
	order dif_EIP, after(sum_flowEFT)
	order dif_EVP, after(sum_flowEIP)
	order dif_UFT, after(sum_flowEVP)
	order dif_UPT, after(sum_flowUFT)
	order dif_NNN, after(sum_flowUPT)
	foreach x of varlist netflowfromEFTtoEFT-netflowfromNNNtoNNN {
		replace `x' = 0 if(`x' == .)
	}
	foreach to of local status{
		order netflowfromEFTto`to', after(dif_`to') 
		order netflowfromEIPto`to', after(netflowfromEFTto`to')
		order netflowfromEVPto`to', after(netflowfromEIPto`to')
		order netflowfromUFTto`to', after(netflowfromEVPto`to') 
		order netflowfromUPTto`to', after(netflowfromUFTto`to') 
		order netflowfromNNNto`to', after(netflowfromUPTto`to')
		order error_`to', after(netflowfromNNNto`to')
		order sum_flow`to', after(error_`to')
	}
	drop flowfrom*
}

keep if (from >= 199601 & from <= 201812)
outsheet from to dif_EFT *toEFT error_EFT sum_flowEFT dif_EIP *toEIP error_EIP sum_flowEIP  dif_EVP *toEVP error_EVP sum_flowEVP /*
*/ dif_UFT *toUFT error_UFT sum_flowUFT dif_UPT *toUPT error_UPT sum_flowUPT dif_NNN *toNNN error_NNN sum_flowNNN  using `current'\decomposition_detail_1996_2018.csv, comma replace
outsheet from to fracEFT fracEIP fracEVP fracUFT fracUPT fracNNN  using `current'\stock_data_detail_1996_2018.csv, comma replace

cd `current'\decomposition_figure_detail
foreach to of local status{
	graph bar netflowfromEFTto`to' netflowfromEIPto`to'  netflowfromEVPto`to' netflowfromUFTto`to' netflowfromUPTto`to' netflowfromNNNto`to' error_`to', bar(6, color(gray)) /*
	*/ over(survey) title("decomposition to `to'", span) graphregion(color(white))  legend(lab(1 "from EF") lab(2 "from EIP")  lab(3 "from EVP") lab(4 "from UF")  lab(5 "from UP") lab(6 "from NN") lab(7 "error")) bargap(-50) stack
	graph export decomposition_to`to'.eps, as(eps) replace
	graph export decomposition_to`to'.png, as(png) replace
}
cd `current'

