% Set xxx to the folder where FLOW_PROBABILITY_DETAIL_SA.csv and
% EMP_STATUS_DETAIL_SA.csv are located

close all
clear all
clc
tol = 1.0e-10;

Data_transition = csvread('xxx\FLOW_PROBABILITY_DETAIL_SA.csv',241,1);   % The 217th row is the data for 1996M1 
Data_transition = [Data_transition(:,2:7) Data_transition(:,9:14) Data_transition(:,16:21) Data_transition(:,23:28) Data_transition(:,30:35)];   % To excluge the transition to the self-state.


Stock_data = csvread('xxx\EMP_STATUS_DETAIL_SA.csv',241,1);
EFT = Stock_data(:,1);
EIP = Stock_data(:,2);
EVP = Stock_data(:,3);
UFT = Stock_data(:,4);
UPT = Stock_data(:,5);
NNN = Stock_data(:,6);

num_stock = size(Stock_data,2)/2;
num_month = size(Stock_data,1);
xp_stock = zeros(num_stock-1,num_month-1);
delta_stock = zeros(num_stock-1,num_month-1);
phat = zeros((num_stock-1)*num_stock,num_month-1);
DIF = zeros(num_stock-1,num_month-1);
for j = 1:num_month-1
    X_EFT = [-EFT(j) -EFT(j) -EFT(j) -EFT(j) -EFT(j);
             EFT(j)  0       0       0       0;
             0       EFT(j)  0       0       0;
             0       0       EFT(j)  0       0;
             0       0       0       EFT(j)  0];
    X_EIP = [EIP(j)  0       0       0       0;
             -EIP(j) -EIP(j) -EIP(j) -EIP(j) -EIP(j);
             0       EIP(j)  0       0       0;
             0       0       EIP(j)  0       0;
             0       0       0       EIP(j)  0];
    X_EVP = [EVP(j)  0       0       0       0;
            0       EVP(j)  0       0       0;
            -EVP(j) -EVP(j) -EVP(j) -EVP(j) -EVP(j);             
            0       0       EVP(j)  0       0;
            0       0       0       EVP(j)  0];
    X_UFT =[UFT(j)  0       0       0       0;
            0       UFT(j)  0       0       0;
            0       0       UFT(j)  0       0;
            -UFT(j) -UFT(j) -UFT(j) -UFT(j) -UFT(j);
            0       0       0       UFT(j)  0];
    X_UPT =[UPT(j)  0       0       0       0;
            0       UPT(j)  0       0       0;
            0       0       UPT(j)  0       0;
            0       0       0       UPT(j)  0;
            -UPT(j) -UPT(j) -UPT(j) -UPT(j) -UPT(j)];    
    X_O = diag(NNN(j)*ones(num_stock-1,1));
    X = [X_EFT X_EIP X_EVP X_UFT X_UPT X_O];
    p = Data_transition(j,:)';
    p(p<tol)=tol;
    delta_s = [EFT(j+1)-EFT(j); EIP(j+1)-EIP(j); EVP(j+1)-EVP(j); UFT(j+1)-UFT(j); UPT(j+1)-UPT(j)];
    delta_stock(:,j) = delta_s;
    Detla=X*p;
    xp_stock(:,j) = Detla;
    W_EFT = (diag(p(1:5)') -kron(p(1:5)', p(1:5)))./EFT(j);
    W_EIP = (diag(p(6:10)') -kron(p(6:10)', p(6:10)))./EIP(j);
    W_EVP = (diag(p(11:15)') -kron(p(11:15)', p(11:15)))./EVP(j);
    W_UFT = (diag(p(16:20)') -kron(p(16:20)', p(16:20)))./UFT(j);
    W_UPT = (diag(p(21:25)') -kron(p(21:25)', p(21:25)))./UPT(j);
    W_NNN = (diag(p(26:30)') -kron(p(26:30)', p(26:30)))./NNN(j);
    RRRRR = zeros(num_stock-1,num_stock-1);
   
    W= [W_EFT RRRRR RRRRR RRRRR RRRRR RRRRR;
        RRRRR W_EIP RRRRR RRRRR RRRRR RRRRR;
        RRRRR RRRRR W_EVP RRRRR RRRRR RRRRR;
        RRRRR RRRRR RRRRR W_UFT RRRRR RRRRR;
        RRRRR RRRRR RRRRR RRRRR W_UPT RRRRR;
        RRRRR RRRRR RRRRR RRRRR RRRRR W_NNN];
    W = inv(W);
    wp = W*p;
    %h = inv([W X'; X  RRRRR])*[wp; delta_s];
    h = [W X'; X  RRRRR]\[wp; delta_s];
    phat(:,j) = h(1:length(p));
    DIF(:,j) = transpose(delta_s - X*phat(:,j));
end 
phat = transpose(phat);
DIF = transpose(DIF);


x=199601;
date = x;
while (x <= 201812)
	x1 = x + 1; 
	if (x-12)/100 == fix((x-12)/100)
		x1 = x + 89;
    end
    x = x1;
    date = [date; x];
end
output = [date [zeros(1,size(phat,2)); phat] EFT EIP EVP UFT UPT NNN];	
dlmwrite('output_detail.csv',output,'precision',16)

%%%%%%%%%%%%%%%%%%%%%%%%%%
% check
disp(max(DIF));

figure
plot(delta_stock(1,:)); hold on
plot(xp_stock(1,:));

figure
plot(Data_transition(:,1)); hold on
plot(phat(:,1));
plot(Data_transition(:,10));
plot(phat(:,10))
plot(Data_transition(:,15));
plot(phat(:,15))

