% Decomposition of total hours
close all
result = dir('*_results.mat');
load(result.name);
filename  = M_.dname;
datafile  = options_.datafile;

set(0,'defaultAxesFontSize',8.5);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',8.5);
set(0,'defaultTextFontName','Times');

data_hours;
ld_hours_data = transpose(log(hours_data) - mean(log(hours_data)));
var3_data = [var(ld_hours_data(1,:)), var(ld_hours_data(3,:)), var(ld_hours_data(2,:))];
cov_temp1_data = cov(ld_hours_data(2,:),ld_hours_data(3,:));
R1_data = corrcoef(ld_hours_data(1,:),ld_hours_data(3,:));
R2_data = corrcoef(ld_hours_data(1,:),ld_hours_data(2,:));
R3_data = corrcoef(ld_hours_data(2,:),ld_hours_data(3,:));
OUTPUT_data = [var3_data, 2*cov_temp1_data(1,2), var3_data(2)/var3_data(1),  sqrt(var3_data(2))/sqrt(var3_data(1)), R1_data(1,2), R2_data(1,2), R3_data(1,2)];

set_variables_index;
drawsinfo = dir([ M_.dname '/metropolis/' M_.fname '_posterior_draws*.mat']);
number_of_last_posterior_draws_file = length(drawsinfo);
simul_innos_temp = load([ M_.dname '/metropolis/' M_.fname '_inno1.mat']);
simul_innos_stock = simul_innos_temp.stock;
endo_nbr = M_.endo_nbr;
exo_nbr = M_.exo_nbr;
drops   = 100;
ind = 0;
%iter = size(exo_simul,1);
y0 = oo_.dr.ys;
k2 = oo_.dr.kstate(find(oo_.dr.kstate(:,2) <= M_.maximum_lag+1),[1 2]);
k2 = k2(:,1)+(M_.maximum_lag+1-k2(:,2))*endo_nbr;
order_var = oo_.dr.order_var;
for i =1:number_of_last_posterior_draws_file
    load_postdraws_temp = [ M_.dname '/metropolis/' M_.fname '_posterior_draws' int2str(i) '.mat'];
    %load_postdraws
    pds_temp = load(load_postdraws_temp);
    number_of_stocks = length(pds_temp.pdraws);
    for j = 1:number_of_stocks
        ind = ind +1;
        para_sets = pds_temp.pdraws{j,1};
        GHU = pds_temp.pdraws{j,2}.ghu;
        GHX = pds_temp.pdraws{j,2}.ghx;
        simul_innos = squeeze(simul_innos_stock(:,:,ind));
        periods  = length(simul_innos);
        drops =  floor(periods/5);
        %number_of_simuls = periods+drops;
        y_ = zeros(size(y0,1),periods+M_.maximum_lag);
        y_(:,1) = y0;
        for h = 2:periods+M_.maximum_lag
            yhat = y_(order_var(k2),h-1);
            y_(order_var,h) = GHX*yhat + GHU*simul_innos(:,h-1);
        end
        select_y_ = y_([n_time hour_per_person n_agg],:);
        var3 = [var(select_y_(1,:)), var(select_y_(2,:)), var(select_y_(3,:))];
        cov_temp1 = cov(select_y_(2,:),select_y_(3,:));
        R1 = corrcoef(select_y_(1,:),select_y_(2,:));
        R2 = corrcoef(select_y_(1,:),select_y_(3,:));
        R3 = corrcoef(select_y_(2,:),select_y_(3,:));
        OUTPUT = [var3, 2*cov_temp1(1,2), var3(2)/var3(1), sqrt(var3(2))/sqrt(var3(1)), R1(1,2), R2(1,2), R3(1,2)]; 
        if ind > 1
            OUTPUT_stock = [OUTPUT_stock; OUTPUT];
        else 
            OUTPUT_stock = OUTPUT;
        end
    end
end
output = [OUTPUT_data; mean(OUTPUT_stock,1); quantile(OUTPUT_stock,0.95); quantile(OUTPUT_stock,0.05)];
csvwrite('decomposition_total_hours.csv',output)
