% irfs_ hours

set(0,'defaultAxesFontSize',11);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',11);
set(0,'defaultTextFontName','Times');

DirectoryName = [ M_.fname '/irfs_hours' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);
% irf_hours
nirf = options_.irf;
shock_name = char(M_.exo_names_long);
val = [n_time hour_per_person n_agg];
val_s = cellstr(char(M_.endo_names_long(val,:)));
irf_tec_hours =[oo_.irfs.n_time_e_z'  oo_.irfs.hour_per_person_e_z'  oo_.irfs.n_agg_e_z']; 
irf_inv_hours =[oo_.irfs.n_time_e_i'  oo_.irfs.hour_per_person_e_i'  oo_.irfs.n_agg_e_i'];
irf_mon_hours =[oo_.irfs.n_time_e_r'  oo_.irfs.hour_per_person_e_r'  oo_.irfs.n_agg_e_r'];
figure
h1=plot(1:nirf,irf_tec_hours(:,1),'-k','linewidth',2); hold on
h2=plot(1:nirf,irf_tec_hours(:,2),'-k','Marker','s','linewidth',1);
h3=plot(1:nirf,irf_tec_hours(:,3),'-k','Marker','^','linewidth',1);
h5=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
legend([h1 h2 h3],{'Total hours','Hours per worker','Employment'},'Location','best','FontSize',11)
legend('boxoff')
box off
print(['technology_shock.eps'],'-depsc2');

figure
h1=plot(1:nirf,irf_inv_hours(:,1),'-k','linewidth',2); hold on
h2=plot(1:nirf,irf_inv_hours(:,2),'-k','Marker','s','linewidth',1);
h3=plot(1:nirf,irf_inv_hours(:,3),'-k','Marker','^','linewidth',1);
h5=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
legend([h1 h2 h3],{'Total hours','Hours per worker','Employment'},'Location','best','FontSize',11)
legend('boxoff')
box off
print(['investment_shock.eps'],'-depsc2');

figure
h1=plot(1:nirf,irf_mon_hours(:,1),'-k','linewidth',2); hold on
h2=plot(1:nirf,irf_mon_hours(:,2),'-k','Marker','s','linewidth',1);
h3=plot(1:nirf,irf_mon_hours(:,3),'-k','Marker','^','linewidth',1);
h5=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
legend([h1 h2 h3],{'Total hours','Hours per worker','Employment'},'Location','best','FontSize',11)
legend('boxoff')
box off
print(['monetary_shock.eps'],'-depsc2');
cd(oldFolder)
