% Conduct stochastic simulation
close all
result = dir('*_results.mat');
load(result.name);
filename  = M_.dname;
datafile  = options_.datafile;
max_lag = 6;

set(0,'defaultAxesFontSize',8.5);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',8.5);
set(0,'defaultTextFontName','Times');
eval(datafile);
dy_obs_data = data_q(:,1);
dc_obs_data = data_q(:,2);
di_obs_data = data_q(:,3);
dw_obs_data = data_q(:,4);
pi_obs_data  = data_q(:,5);
rn_obs_data = data_q(:,6);
n_obs_data  =  data_q(:,7);
w_fp_obs_data = data_q(:,8);
l_fp_obs_data  = data_q(:,9);
data_for_auto = [dy_obs_data, dc_obs_data,dw_obs_data,pi_obs_data ,n_obs_data];
%data_for_auto = data_for_auto./100;
data_ACF = xcov(data_for_auto,max_lag,'unbiased');
data_ACF = data_ACF(max_lag+1:end,:);

periods = length(data_q);
drops   = ceil(periods/5);
periods = periods + drops;
drawsinfo = dir([ M_.dname '/metropolis/' M_.fname '_posterior_draws*.mat']);
number_of_last_posterior_draws_file = length(drawsinfo);
%simul_innos_temp = load([ M_.dname '/metropolis/' M_.fname '_inno1.mat']);
%simul_innos_stock = simul_innos_temp.stock;
endo_nbr = M_.endo_nbr;
exo_nbr = M_.exo_nbr;
num_simul = 150;
rand_shock = randn(exo_nbr,num_simul*periods);
for i = 1:M_.endo_nbr
    eval(cell2mat(strcat(M_.endo_names(i,:),'=',num2str(i),';')));
end
selected_variable_ACF = [dy_obs dc_obs dw_obs pi_obs n_obs];
selected_variable_labor = [n_ful n_pat n_ful_cf n_pat_cf dy_obs];

y0 = oo_.dr.ys;
k2 = oo_.dr.kstate(find(oo_.dr.kstate(:,2) <= M_.maximum_lag+1),[1 2]);
k2 = k2(:,1)+(M_.maximum_lag+1-k2(:,2))*endo_nbr;
order_var = oo_.dr.order_var;
ind = 0;
for i =1:number_of_last_posterior_draws_file
    load_postdraws_temp = [ M_.dname '/metropolis/' M_.fname '_posterior_draws' int2str(i) '.mat'];
    pds_temp = load(load_postdraws_temp);
    number_of_stocks = length(pds_temp.pdraws);
    for j = 1:number_of_stocks
        for s = 1:num_simul
            ind = ind +1;
        end
    end
end
model_ACF_stock = zeros(max_lag+1,length(selected_variable_ACF)^2,ind);
cr_labor = zeros(max_lag*2+1,4,ind);
ind =0;
for i =1:number_of_last_posterior_draws_file
    load_postdraws_temp = [ M_.dname '/metropolis/' M_.fname '_posterior_draws' int2str(i) '.mat'];
    pds_temp = load(load_postdraws_temp);
    number_of_stocks = length(pds_temp.pdraws);
    for j = 1:number_of_stocks
        GHU = pds_temp.pdraws{j,2}.ghu;
        GHX = pds_temp.pdraws{j,2}.ghx;
        para_sets = pds_temp.pdraws{j,1};
        exo_std_est = para_sets(1:exo_nbr);
        chol_shock = diag(exo_std_est);
        exo_simul = transpose(rand_shock'*chol_shock);
        zstar = para_sets(26);
        for s = 1:num_simul
            ind = ind +1;
            y_ = zeros(size(y0,1),periods);
            y_(:,1) = y0;
            simul_innos = exo_simul(:,periods*(s-1)+1:periods*s);
            %simul_innos = squeeze(simul_innos_stock(:,:,ind));
            for h = 2:periods
               yhat = y_(order_var(k2),h-1);
               y_(order_var,h) = GHX*yhat + GHU*simul_innos(:,h-1);
            end
            y_ = y_(:,drops+1:end); 
            select_y_ = y_(selected_variable_ACF,:);
            select_y_labor = y_(selected_variable_labor,:);
            log_real_gdp = zeros(size(y_(dy_obs,:)))-10;
            for ii = 2:length(y_(dy_obs,:))
                log_real_gdp(ii) = zstar/100 + log_real_gdp(ii-1) + y_(dy_obs,ii)/100;
            end
            [T,C]= hpfilter(log_real_gdp,1600);
            [cr_nful_hp,lgs_ylf_hp] = xcov(select_y_labor(1,:)-mean(select_y_labor(1,:)), 100*C, max_lag,'coeff');
            [cr_npat_hp,lgs_ylf_hp] = xcov(select_y_labor(2,:)-mean(select_y_labor(2,:)), 100*C, max_lag,'coeff');
            [cr_nful_cf_hp,lgs_ylf_hp] = xcov(select_y_labor(3,:)-mean(select_y_labor(3,:)), 100*C, max_lag,'coeff');
            [cr_npat_cf_hp,lgs_ylf_hp] = xcov(select_y_labor(4,:)-mean(select_y_labor(4,:)), 100*C, max_lag,'coeff');
            cr_labor(:,:,ind) = [cr_nful_hp; cr_npat_hp; cr_nful_cf_hp; cr_npat_cf_hp]'; 
            model_ACF = xcov(select_y_',max_lag,'unbiased');
            model_ACF = model_ACF(max_lag+1:end,:);
            model_ACF_stock(:,:,ind) = model_ACF;
%             if ind > 1
%                 model_ACF_stock = cat(3,model_ACF_stock,model_ACF);
%             else 
%                 model_ACF_stock = model_ACF;
%             end
         end
    end
end

statics_model_ACF_stock = cat(3,squeeze(mean(permute(model_ACF_stock,[3 1 2]))), squeeze(quantile(permute(model_ACF_stock,[3 1 2]),0.05)), squeeze(median(permute(model_ACF_stock,[3 1 2]))), squeeze(quantile(permute(model_ACF_stock,[3 1 2]),0.95)));

til_variables = ['$dy_{t}$, $dy_{t+k}$  '; '$dy_{t}$, $dc_{t+k}$  '; '$dy_{t}$, $dw_{t+k}$  '; '$dy_{t}$, $\pi_{t+k}$ '; '$dy_{t}$, $n_{t+k}$   '; ...
                 '$dc_{t}$, $dy_{t+k}$  '; '$dc_{t}$, $dc_{t+k}$  '; '$dc_{t}$, $dw_{t+k}$  '; '$dc_{t}$, $\pi_{t+k}$ '; '$dc_{t}$, $n_{t+k}$   '; ...  
                 '$dw_{t}$, $dy_{t+k}$  '; '$dw_{t}$, $dc_{t+k}$  '; '$dw_{t}$, $dw_{t+k}$  '; '$dw_{t}$, $\pi_{t+k}$ '; '$dw_{t}$, $n_{t+k}$   '; ... 
                 '$\pi_{t}$, $dy_{t+k}$ '; '$\pi_{t}$, $dc_{t+k}$ '; '$\pi_{t}$, $dw_{t+k}$ '; '$\pi_{t}$, $\pi_{t+k}$'; '$\pi_{t}$, $n_{t+k}$  '; ...
                 '$n_{t}$, $dy_{t+k}$   '; '$n_{t}$, $dc_{t+k}$   '; '$n_{t}$, $dw_{t+k}$   '; '$n_{t}$, $\pi_{t+k}$  '; '$n_{t}$, $n_{t+k}$    '];
cell_til_variables = cellstr(til_variables);
xa = [0:1:max_lag];
ind = 0;
n_selected_variables = 5;
figure('Name','Autocovariance function');
for i = 1:n_selected_variables
    for j = 1:n_selected_variables
        ind = ind +1;
        %[auto_data,lgs_ylp] = xcov(data_for_auto(:,i)-mean(data_for_auto(:,i)) , data_for_auto(:,j)-mean(data_for_auto(:,j)), max_lag,'coeff');
        subplot(n_selected_variables,n_selected_variables,ind)
        plot(xa, squeeze(statics_model_ACF_stock(:,ind,2)),'Color',[0 0.7 0],'LineWidth',1.0);   hold on
        plot(xa, squeeze(statics_model_ACF_stock(:,ind,4)),'Color',[0 0.7 0],'LineWidth',1.0); 
        plot(xa, data_ACF(:,ind),'r:','LineWidth',1.25);
        ax = gca;
        set(ax,'XTick',[0  2 4 6]);
        %set(ax,'YTick',[0 0.5 1]);
        min_y = min(min(squeeze(statics_model_ACF_stock(:,ind,2))), min(data_ACF(:,ind)));
        %min_y = min_y - 0.1*min_y;
        max_y = max(max(squeeze(statics_model_ACF_stock(:,ind,4))), max(data_ACF(:,ind)));
        %max_y = max_y + 0.1*max_y;
        mid_y = (min_y + max_y)/2;
        span_y = 1.2*(max_y - min_y);
        max_y = mid_y + span_y/2;
        min_y = mid_y - span_y/2;
        axis tight
        ylim([min_y max_y])        
        title(deblank(char(cell_til_variables(ind))),'interpreter','latex')
    end
end
DirectoryName = [ M_.fname '/Autocovariance' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);
print(['ACVFs.eps'],'-depsc2');
cd(oldFolder);

DirectoryName = M_.fname;
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);
statics_cr_labor = cat(3,squeeze(mean(permute(cr_labor,[3 1 2]))), squeeze(quantile(permute(cr_labor,[3 1 2]),0.05)),squeeze(median(permute(cr_labor,[3 1 2]))), squeeze(quantile(permute(cr_labor,[3 1 2]),0.95)));
full_time = [statics_cr_labor(max_lag+1,1,1) statics_cr_labor(max_lag+1,1,2)  statics_cr_labor(max_lag+1,1,4)  statics_cr_labor(max_lag+1,3,1) statics_cr_labor(max_lag+1,3,2)  statics_cr_labor(max_lag+1,3,4),  0.549];
part_time = [statics_cr_labor(max_lag+1,2,1) statics_cr_labor(max_lag+1,2,2)  statics_cr_labor(max_lag+1,2,4)  statics_cr_labor(max_lag+1,4,1) statics_cr_labor(max_lag+1,4,2)  statics_cr_labor(max_lag+1,4,4),  -0.366]; 
diary('statics_ACF_labor.txt')
diary on
disp(datestr(clock));
disp('Full-time Employment');
disp(full_time)
disp('Part-time Employment');
disp(part_time)
diary off
cd(oldFolder);
