% Depict Bayesian irf: comparison between EF and EP

set(0,'defaultAxesFontSize',9);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',9.5);
set(0,'defaultTextFontName','Times');
shock_name_temp = char('Technology','Intertemporal Preferences','Investment','Price Markup','Government Spending','Monetary Policy','Bargaining (Full-Time)','Bargaining (Part-Time)','Part-Time Labor Productivity');

DirectoryName = [ M_.fname '/bvar_irfs_full_part' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
nirf = 40;
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);
variable = varlist_n_ful;
variable2 = varlist_n_pat;
variable3 = varlist_u;
figure('Name','Posterior BVAR Impulse Responses Full-time versus Part-time Employment');
for shock=1:nvx
    fig = subplot(number_of_rows,number_of_columns,shock);
    hold on
    h7=plot(1:nirf,squeeze(HPDIRFdsgevar(:,1,variable3,shock)),':c','linewidth',1, 'Color', [0.4940 0.1840 0.5560]);
    h8=plot(1:nirf,squeeze(HPDIRFdsgevar(:,2,variable3,shock)),':c','linewidth',1, 'Color', [0.4940 0.1840 0.5560]);
    h9=plot(1:nirf,squeeze(MedianIRFdsgevar(:,variable3,shock)),'-','linewidth',1.5, 'Color', [0.4940 0.1840 0.5560], 'Marker','.', 'MarkerSize' ,8);

    h1=plot(1:nirf,squeeze(HPDIRFdsgevar(:,1,variable,shock)),'-k','linewidth',1);
    h2=plot(1:nirf,squeeze(HPDIRFdsgevar(:,2,variable,shock)),'-k','linewidth',1);
    h3=plot(1:nirf,squeeze(MedianIRFdsgevar(:,variable,shock)),'-k','linewidth',2);

    h4=plot(1:nirf,squeeze(HPDIRFdsgevar(:,1,variable2,shock)),':b','linewidth',1);
    h5=plot(1:nirf,squeeze(HPDIRFdsgevar(:,2,variable2,shock)),':b','linewidth',1);
    h6=plot(1:nirf,squeeze(MedianIRFdsgevar(:,variable2,shock)),'--b','linewidth',2);

    h10=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
    hold off
    axis tight
    ytickformat('%.1f')
    title(fig,deblank(char(shock_name_temp(shock,:))))
end
legend([h3 h6, h9],{'Full-Time','Part-Time', 'Unemployment'},'Orientation','horizontal','Position',[.45 .024 .15 0.024],'FontSize',11)
legend('boxoff')
print(['PostIRFs_Full_vs_Part40.eps'],'-depsc2');
nirf = 20;
figure('Name','Posterior BVAR Impulse Responses Full-time versus Part-time Employment');
for shock=1:nvx
    fig = subplot(number_of_rows,number_of_columns,shock);
    hold on
    h1=plot(1:nirf,squeeze(HPDIRFdsgevar(1:nirf,1,variable,shock)),'-k','linewidth',1);
    h2=plot(1:nirf,squeeze(HPDIRFdsgevar(1:nirf,2,variable,shock)),'-k','linewidth',1);
    h3=plot(1:nirf,squeeze(MedianIRFdsgevar(1:nirf,variable,shock)),'-k','linewidth',2);
    h4=plot(1:nirf,squeeze(HPDIRFdsgevar(1:nirf,1,variable2,shock)),':b','linewidth',1);
    h5=plot(1:nirf,squeeze(HPDIRFdsgevar(1:nirf,2,variable2,shock)),':b','linewidth',1);
    h6=plot(1:nirf,squeeze(MedianIRFdsgevar(1:nirf,variable2,shock)),'--b','linewidth',2);
    h7=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
    hold off
    axis tight
    ytickformat('%.1f')
    title(fig,deblank(char(shock_name_temp(shock,:))))
end
legend([h3 h6],{'Full-Time','Part-Time'},'Orientation','horizontal','Position',[.45 .024 .15 0.024],'FontSize',11)
legend('boxoff')
print(['PostIRFs_Full_vs_Part20.eps'],'-depsc2');

figure('Name','Posterior BVAR Impulse Responses Full-time versus Part-time Employment');
for shock=1:nvx
    fig = subplot(number_of_rows,number_of_columns,shock);
    hold on
    h3=plot(1:nirf,squeeze(MedianIRFdsgevar(1:nirf,variable,shock)),'-k','linewidth',2);
    h6=plot(1:nirf,squeeze(MedianIRFdsgevar(1:nirf,variable2,shock)),':b','linewidth',2);
    h9=plot(1:nirf,squeeze(MedianIRFdsgevar(1:nirf,variable3,shock)),'-','linewidth',1.5, 'Color', [0.4940 0.1840 0.5560], 'Marker','.', 'MarkerSize' ,10);
    h7=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
    hold off
    axis tight
    ytickformat('%.1f')
    title(fig,deblank(char(shock_name_temp(shock,:))))
end
legend([h3 h6 h9],{'Full-Time Employment','Part-Time Employment', 'Unemployment'},'Orientation','horizontal','Position',[.45 .024 .15 0.024],'FontSize',11)
legend('boxoff')
print(['PostIRFs_FPU20.eps'],'-depsc2');
cd(oldFolder)
