% depict Bayesion_irf: counterfactual
set(0,'defaultAxesFontSize',13);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',13);
set(0,'defaultTextFontName','Times');

nirf = 20;
shock = 3;
DirectoryName = [ M_.fname '/bvar_counterfactual' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);
variable = varlist_n_ful;
variable_cf = varlist_n_ful_cf;
variable2 = varlist_n_pat;
variable2_cf = varlist_n_pat_cf;
variable3 = varlist_u;
variable3_cf = varlist_u_cf;
figure('Name','Impulse Responses Full-time Employment');
h1=plot(1:nirf,squeeze(-HPDIRFdsgevar(1:nirf,1,variable,shock)),'-k','linewidth',2.5);   hold on
h2=plot(1:nirf,squeeze(-HPDIRFdsgevar(1:nirf,1,variable_cf,shock)),':k','linewidth',2.5);
h3=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
legend([h1 h2],{'Baseline','Counterfactual'},'Orientation','horizontal','Position',[.45 .024 .15 0.024],'FontSize',13.5)
legend('boxoff')
xticks([5 10 15 20])
hold off
axis tight
ylim([min( min(-HPDIRFdsgevar(1:nirf,1,variable,shock)), min(-HPDIRFdsgevar(1:nirf,1,variable_cf,shock)))*1.15, max(max(-HPDIRFdsgevar(1:nirf,1,variable,shock)), max(-HPDIRFdsgevar(1:nirf,1,variable_cf,shock)))*1.15]);
ytickformat('%.1f')
box off
print(['Comparison_EF20_IST.eps'],'-depsc2');

figure('Name','Impulse Responses Part-time Employment');
h1=plot(1:nirf,squeeze(-HPDIRFdsgevar(1:nirf,1,variable2,shock)),'-k','linewidth',2.5);   hold on
h2=plot(1:nirf,squeeze(-HPDIRFdsgevar(1:nirf,1,variable2_cf,shock)),':k','linewidth',2.5);
h3=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
legend([h1 h2],{'Baseline','Counterfactual'},'Orientation','horizontal','Position',[.45 .024 .15 0.024],'FontSize',13.5)
legend('boxoff')
hold off
xticks([5 10 15 20])
axis tight
ylim([min( min(-HPDIRFdsgevar(1:nirf,1,variable2,shock)), min(-HPDIRFdsgevar(1:nirf,1,variable2_cf,shock)))*1.15, max(max(-HPDIRFdsgevar(1:nirf,1,variable2,shock)), max(-HPDIRFdsgevar(1:nirf,1,variable2_cf,shock)))*1.15]);
ytickformat('%.1f')
box off
print(['Comparison_EP20_IST.eps'],'-depsc2');

figure('Name','Impulse Responses Unemployment');
h1=plot(1:nirf,squeeze(-HPDIRFdsgevar(1:nirf,1,variable3,shock)),'-k','linewidth',2.5);   hold on
h2=plot(1:nirf,squeeze(-HPDIRFdsgevar(1:nirf,1,variable3_cf,shock)),':k','linewidth',2.5);
h3=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
legend([h1 h2],{'Baseline','Counterfactual'},'Orientation','horizontal','Position',[.45 .024 .15 0.024],'FontSize',13.5)
legend('boxoff')
hold off
xticks([5 10 15 20])
axis tight
ylim([min( min(-HPDIRFdsgevar(1:nirf,1,variable3,shock)), min(-HPDIRFdsgevar(1:nirf,1,variable3_cf,shock)))*1.15, max(max(-HPDIRFdsgevar(1:nirf,1,variable3,shock)), max(-HPDIRFdsgevar(1:nirf,1,variable3_cf,shock)))*1.15]);
ytickformat('%.1f')
box off
print(['Comparison_UMP20_IST.eps'],'-depsc2');
cd(oldFolder)