% Conterfactual simulation
nf1 = 0.762897973;
np1 = 0.173180744;
u1= 1-nf1-np1;
USdata = 100*csvread('US_data_NF_NP_U_after2006.csv');
for i = 1:n_exo
    if i == 1
        shock_smooth = eval(char(strcat('oo_.SmoothedShocks.',M_.exo_names(1,:))));
    else
        shock_smooth = [shock_smooth, eval(char(strcat('oo_.SmoothedShocks.',M_.exo_names(i,:))))];
    end
end  
filename_save =[ M_.fname '/smoothed_shocks.mat' ];
save(filename_save, 'shock_smooth');

% initialization
cellendoname = cellstr(endonames);
init_smoothed = zeros(nendo,1);
for i = 1:nendo
    vec_smooth = eval(strcat('oo_.SmoothedVariables.', char(cellendoname(i))));
    init_smoothed(i) = vec_smooth(1);
end

cf_length = size(shock_smooth,1);
yp_cf = zeros(size(oo_.dr.ys,1), cf_length);
exo_simul = shock_smooth;
epsilon = oo_.dr.ghu*transpose(exo_simul);
% remove the steady state value
% if ~options_.k_order_solver || (options_.k_order_solver && options_.pruning) %if k_order_pert is not used or if we do not use Dynare++ with k_order_pert
%     if iorder==1
%         yp_cf(:,1) = yp_cf(:,1)-oo_.dr.ys;
%     end
% end
if options_.block
    if M_.maximum_lag > 0
        k2 = oo_.dr.state_var;
    else
        k2 = [];
    end;
    order_var = 1:endo_nbr;
else
    k2 = oo_.dr.kstate(find(oo_.dr.kstate(:,2) <= M_.maximum_lag+1),[1 2]);
    k2 = k2(:,1)+(M_.maximum_lag+1-k2(:,2))*endo_nbr;
    order_var = oo_.dr.order_var;
end;
yp_cf(:,1) = init_smoothed;
for i = 2:cf_length
    yhat = yp_cf(order_var(k2),i-1);
    yp_cf(order_var,i) = oo_.dr.ghx*yhat + epsilon(:,i);
end

yp_cf_labor = yp_cf([n_ful, n_pat, u, n_ful_cf, n_pat_cf, u_cf],:);
%yp_cf_ss = [nss_ful  nss_pat   uss nss_ful  nss_pat   uss];
yp_cf_ss = [nf1  np1   u1  nf1  np1   u1];
set(0,'defaultAxesFontSize',10);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',10);
set(0,'defaultTextFontName','Times');

DirectoryName = [ M_.fname '/couterfactual_experiment' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);

level = zeros(size(yp_cf_labor));
for i = 1:2
    j = 3+i;
    level(i,:) = yp_cf_ss(i) + yp_cf_ss(i)*yp_cf_labor(i,:)./100;
    level(j,:) = yp_cf_ss(j) + yp_cf_ss(j)*yp_cf_labor(j,:)./100;
end
level(3,:) = 1-(level(1,:)+level(2,:));
level(6,:) = 1-(level(4,:)+level(5,:));

val = [dy_obs di_obs dc_obs dw_obs pi_obs u nu rn];
val_s = cellstr(char(M_.endo_names_long(val,:)));
figure
for i = 1:3
    j = 3+i;
    subplot(2,2,i)
    line1=plot(xData(1:end), 100*(level(i,:)), 'Color',[0.1,0.1,0.1],'LineWidth',2.0); hold on
    line2=plot(xData(1:end), 100*(level(j,:)), 'Color',[0.1,0.1,0.1],'LineWidth',2.0, 'LineStyle',':');
    %line2=plot(xData(1:end),spat_level(:,2), 'Color',[0 0.7 0],'LineWidth',0.5); 
    %line3=plot(xData(1:end),spat_level(:,3), 'Color',[0 0.7 0],'LineWidth',0.5);
    %y_gridmm = [max(max(spat_level)) min(min(spat_level))];
    curax=axis;
    yy=[curax(3) curax(4) curax(4) curax(3)];
    colorstr=[0.8 0.8 0.8];
    %yy=[y_gridmm(2) y_gridmm(1) y_gridmm(1) y_gridmm(2)];

    for ii=1:length(start);
        x=[start(ii) start(ii) finish(ii) finish(ii)];
        ps = patch(x,yy,colorstr,'FaceAlpha',0.7,'EdgeColor','none');
        uistack(ps,'bottom')
    end
    hold off;
    title(sprintf('%s',deblank(char(val_s(i)))));
    set(gca,'XTick',xData)
    datetick('x','yyyy')
    axis tight
end
legend([line1 line2],{'Benchmark','Counterfactual'},'Orientation','horizontal','Position',[.4 .025 .2 0.025],'FontSize',11)
legend('boxoff')
print(['counterfactual_simulation_labor.eps'],'-depsc2');
cd(oldFolder);

cf_val = [lambda_cf y_cf y_ful_cf y_pat_cf k_ful_cf k_pat_cf n_ful_cf n_pat_cf c_cf i_cf  nu_cf x_ful_cf x_pat_cf  u_ful_cf u_pat_cf u_cf ...
v_ful_cf v_pat_cf s_ful_cf s_pat_cf kp_cf e_ful_cf e_pat_cf Lam_cf rn_cf pi_cf rk_cf qk_cf ...
pw_cf pw_ful_cf pw_pat_cf w_ful_cf w_pat_cf chi_ful_cf chi_pat_cf mu_ful_cf mu_pat_cf  wo_ful_cf  wo_pat_cf  b_cf ...
J_ful_cf J_pat_cf H_x_ful_cf H_x_pat_cf];
cf_val_wo = [lambda y y_ful y_pat k_ful k_pat n_ful n_pat c i  nu x_ful x_pat  u_ful u_pat u ...
v_ful v_pat s_ful s_pat kp e_ful e_pat Lam rn pi rk qk ...
pw pw_ful pw_pat w_ful w_pat chi_ful chi_pat mu_ful mu_pat  wo_ful  wo_pat  b ...
J_ful J_pat H_x_ful H_x_pat];
initial_gr = 4*(2006-1979)+1; % ('01-01-2006')
startDate1 = datenum('01-01-2006');
endDate1 = datenum('10-01-2018');
xData1 = linspace(startDate1,endDate1,4*(2019-2006));
% recession
start1=[datenum('12-01-2007')];
finish1=[datenum('06-01-2009')];

init_smoothed_gr = yp_cf(:,initial_gr);
init_smoothed_gr(cf_val,:) = yp_cf(cf_val_wo,initial_gr);

shock_smooth_gr =  shock_smooth(initial_gr:end,:);
cf_length_gr = size(shock_smooth_gr,1);
yp_cf_gr = zeros(size(oo_.dr.ys,1), cf_length_gr);
epsilon = oo_.dr.ghu*transpose(shock_smooth_gr);

% construction of k2
% if ~options_.k_order_solver || (options_.k_order_solver && options_.pruning) %if k_order_pert is not used or if we do not use Dynare++ with k_order_pert
%     if iorder==1
%         yp_cf_gr(:,1) = yp_cf_gr(:,1)-oo_.dr.ys;
%     end
% end
if options_.block
    if M_.maximum_lag > 0
        k2 = oo_.dr.state_var;
    else
        k2 = [];
    end
    order_var = 1:endo_nbr;
else
    k2 = oo_.dr.kstate(find(oo_.dr.kstate(:,2) <= M_.maximum_lag+1),[1 2]);
    k2 = k2(:,1)+(M_.maximum_lag+1-k2(:,2))*endo_nbr;
    order_var = oo_.dr.order_var;
end
yp_cf_gr(:,1) = init_smoothed_gr;
for i = 2:cf_length_gr
    yhat = yp_cf_gr(order_var(k2),i-1);
    yp_cf_gr(order_var,i) = oo_.dr.ghx*yhat + epsilon(:,i);
end


yp_labor_gr = yp_cf_gr([n_ful, n_pat, u, n_ful_cf, n_pat_cf, u_cf],1:end);
%filename_save =[ M_.fname '/smoothed_varables_GR.mat' ];
%save(filename_save, 'y_labor_gr','init_smoothed_gr','initial_gr','cf_length_gr','startDate1','endDate1','xData1');
val_ss = {'Full-Time Employment' 'Part-Time Employment','Unemployment Rate'};

DirectoryName = [ M_.fname '/couterfactual_experiment_great_recession' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);

level = zeros(size(yp_labor_gr));
for i = 1:2
    j = 3+i;
    level(i,:) = yp_cf_ss(i) + yp_cf_ss(i)*yp_labor_gr(i,:)./100;
    level(j,:) = yp_cf_ss(j) + yp_cf_ss(j)*yp_labor_gr(j,:)./100;
end
level(3,:) = 1-(level(1,:)+level(2,:));
level(6,:) = 1-(level(4,:)+level(5,:));

figure
for i = 1:3
    subplot(2,3,i)
    j = 3+i;
    line2=plot(xData1(1:end), 100*(level(j,:)), 'Color',[0.1,0.1,0.1],'LineWidth',1.5, 'Color',[0.5 0.5 0.5], 'Marker','*', 'MarkerSize',3.5); hold on
    line1=plot(xData1(1:end), 100*(level(i,:)), 'Color','blue','LineWidth',1.5); 
    line3=plot(xData1(1:end), USdata([1:1:size(xData1,2)],i),'r:','linewidth',1.5);
        %line2=plot(xData1(1:end), 100*(yp_cf_ss(i) + yp_cf_ss(i)*y_gr_labor_cf(i,:)./100), 'Color',[0.1,0.1,0.1],'LineWidth',1.5, 'LineStyle',':');        
    %line2=plot(xData(1:end),spat_level(:,2), 'Color',[0 0.7 0],'LineWidth',0.5); 
    %line3=plot(xData(1:end),spat_level(:,3), 'Color',[0 0.7 0],'LineWidth',0.5);
    %y_gridmm = [max(max(spat_level)) min(min(spat_level))];
    curax=axis;
    yy=[curax(3) curax(4) curax(4) curax(3)];
    colorstr=[0.8 0.8 0.8];
    %yy=[y_gridmm(2) y_gridmm(1) y_gridmm(1) y_gridmm(2)];

    for ii=1:length(start1);
        x=[start1(ii) start1(ii) finish1(ii) finish1(ii)];
        ps = patch(x,yy,colorstr,'FaceAlpha',0.7,'EdgeColor','none');
        uistack(ps,'bottom')
    end
    hold off;
    title(sprintf('%s',deblank(char(val_ss(i)))));
    %set(gca,'XTick',xData1)
    xticks([xData1(1) xData1(13)+1 xData1(25)+1 xData1(37)+1 xData1(49)+1])
    %xticklabels({'x = 0','x = 5','x = 10'})
    datetick('x','yyQQ','keepticks')
    axis tight
    box off
end
legend([line1 line2 line3],{'Baseline','Counterfactual','US Data'},'Orientation','horizontal','Position',[.4 .335 .2 0.335],'FontSize',11)
legend('boxoff')
print(['counterfactual_simulation_labor_GR_3_panels.eps'],'-depsc2');
print(['counterfactual_simulation_labor_GR_3_panels.pdf'],'-dpdf');
cd(oldFolder);
