set more off, permanently
local current `"****"'											/* Specify the current folder */
local current_data `"*****"'									/* Specify the folder that contains dta files */
cd `current'
capture mkdir CSV_file
capture mkdir Figure
local current_figure `"***"'									/* Specify the folder that saves figures produced here */								


insheet using CPImonth.csv, clear
gen survey=ym(year,month)
replace cpi = cpi/100
save CPImonth, replace

forvalues t = 79/93 {
	quietly use `current_data'\morg`t'.dta , clear
	if `t' <= 82{
		keep minsamp  weight earnwt year intmonth age race sex marital state gradeat gradecp esr class hourslw uhourse earnwke ftpt79 dind  docc70
	}
	else if (`t'>82 & `t'<=88) {
		keep minsamp  weight earnwt year intmonth age race sex marital state gradeat gradecp esr class hourslw uhourse earnwke ftpt79 dind  docc80
	}
	else if (`t'>89 & `t'<= 91) {
		keep minsamp  weight earnwt year intmonth age race sex marital stfips gradeat gradecp lfsr89 class hourslw uhourse  earnwke ftpt89 dind  docc80
	}
	quietly{	
		gen  edu = .
		if (`t'<= 91) {
			replace  edu = 0 if gradeat <= 11 & gradeat > 0
			replace  edu = 1 if gradeat == 12 & gradecp == 1
			replace  edu = 1 if gradeat >= 13
			replace  edu = 2 if gradeat == 16 & gradecp == 1
			replace  edu = 2 if gradeat >= 17
			drop  gradeat  gradecp
		}
		else if (`t' > 91) {
			replace  edu = 0 if grade92 <= 38
			replace  edu = 1 if grade92 >= 39
			replace  edu = 2 if grade92 >= 41
			drop grade92
		}
	
		if (`t'<=88) {
			gen  lstate= esr
			drop if inlist(lstate,  4, 5, 6, 7)	| lstate==.					/* omit NILF*/
			egen emp = anymatch(lstate), v(1/2)
			egen ump = anymatch(lstate), v(3)
			gen  ump_fl = .
			gen  ump_pt = .
			replace ump_fl = 0 if ump == 1
			replace ump_pt = 0 if ump == 1
			replace ump_fl = 1 if ump == 1 & ftpt79 == 3					/* Unemployed for full-time jobs*/
			replace ump_pt = 1 if ump == 1 & ftpt79 == 5					/* Unemployed for part-time jobs*/
			gen l2fp =.
			replace l2fp = 1 if ftpt79 == 1 & lstate == 2
			replace l2fp = 2 if inlist(ftpt79, 2, 4) & lstate == 2
			drop esr  ftpt79
			
			gen stfips =.
			replace stfips = 23 if state == 11	/*  "ME"    */                        
			replace stfips = 33 if state == 12	/*  "NH"    */
			replace stfips = 50 if state == 13	/*  "VT"  	*/
			replace stfips = 25 if state == 14	/*  "MA"    */
			replace stfips = 44 if state == 15  /*  "RI"	*/ 
			replace stfips =  9 if state == 16  /*  "CT"	*/
			replace stfips = 36 if state == 21  /*  "NY"    */
			replace stfips = 34 if state == 22  /*  "NJ"    */
			replace stfips = 42 if state == 23  /*  "PA"    */
			replace stfips = 39 if state == 31  /*  "OH"    */
			replace stfips = 18 if state == 32  /*  "IN"    */
			replace stfips = 17 if state == 33  /*  "IL"	*/
			replace stfips = 26 if state == 34  /*  "MI" 	*/
			replace stfips = 55 if state == 35  /*  "WI"    */
			replace stfips = 27 if state == 41  /*  "MN"  	*/
			replace stfips = 19 if state == 42  /*  "IA"  	*/
			replace stfips = 29 if state == 43  /*  "MO"    */
			replace stfips = 38 if state == 44  /*  "ND"	*/
			replace stfips = 46 if state == 45  /*  "SD" 	*/ 
			replace stfips = 31 if state == 46  /*  "NE"	*/
			replace stfips = 20 if state == 47  /*  "KS" 	*/	
			replace stfips = 10 if state == 51  /*  "DE"    */      
			replace stfips = 24 if state == 52  /*  "MD"    */ 			
			replace stfips = 11 if state == 53  /*  "DC"	*/
			replace stfips = 51 if state == 54  /*  "VA" 	*/                           
			replace stfips = 54 if state == 55  /*  "WV"    */
			replace stfips = 37 if state ==	56  /*  "NC"    */ 
			replace stfips = 45 if state ==	57  /*  "SC"    */ 
			replace stfips = 13 if state == 58  /*  "GA"    */ 
			replace stfips = 12 if state == 59  /*  "FL"    */  
			replace stfips = 21 if state == 61  /*  "KY"    */
			replace stfips = 47 if state == 62  /*  "TN"    */
            replace stfips =  1 if state == 63  /*  "AL"    */               
            replace stfips = 28 if state == 64  /*  "MS"    */                
            replace stfips =  5 if state == 71  /*  "AR"    */ 
            replace stfips = 22 if state == 72  /*  "LA"    */               
            replace stfips = 40 if state == 73  /*  "OK" 	*/
			replace stfips = 48 if state == 74  /*  "TX" 	*/
	        replace stfips = 30 if state == 81  /*  "MT"    */
			replace stfips = 16 if state == 82  /*  "ID"    */
			replace stfips = 56 if state == 83  /*  "WY"    */
			replace stfips =  8 if state == 84  /*  "CO"    */
			replace stfips = 35 if state == 85  /*  "NM"    */	                            
            replace stfips =  4 if state == 86  /*  "AZ"    */               
            replace stfips = 49 if state == 87  /*  "AZ"    */
			replace stfips = 32 if state == 88  /*  "NV"    */
			replace stfips = 53 if state == 91  /*  "WA"    */               
            replace stfips = 41 if state == 92  /*  "OR"    */
			replace stfips =  6 if state == 93  /*  "CA"    */
			replace stfips =  2 if state == 94  /*  "AK"    */
			replace stfips = 15 if state == 95  /*  "HI"    */		
		
			
			label define stfips_lbl 1           "AL"
			label define stfips_lbl 2           "AK", add
			label define stfips_lbl 4           "AZ", add
			label define stfips_lbl 5           "AR", add
			label define stfips_lbl 6           "CA", add
			label define stfips_lbl 8           "CO", add
			label define stfips_lbl 9           "CT", add
			label define stfips_lbl 10          "DE", add
			label define stfips_lbl 11          "DC", add
			label define stfips_lbl 12          "FL", add
			label define stfips_lbl 13          "GA", add
			label define stfips_lbl 15          "HI", add
			label define stfips_lbl 16          "ID", add
			label define stfips_lbl 17          "IL", add
			label define stfips_lbl 18          "IN", add
			label define stfips_lbl 19          "IA", add
			label define stfips_lbl 20          "KS", add
			label define stfips_lbl 21          "KY", add
			label define stfips_lbl 22          "LA", add
			label define stfips_lbl 23          "ME", add
			label define stfips_lbl 24          "MD", add
			label define stfips_lbl 25          "MA", add
			label define stfips_lbl 26          "MI", add
			label define stfips_lbl 27          "MN", add
			label define stfips_lbl 28          "MS", add
			label define stfips_lbl 29          "MO", add
			label define stfips_lbl 30          "MT", add
			label define stfips_lbl 31          "NE", add
			label define stfips_lbl 32          "NV", add
			label define stfips_lbl 33          "NH", add
			label define stfips_lbl 34          "NJ", add
			label define stfips_lbl 35          "NM", add
			label define stfips_lbl 36          "NY", add
			label define stfips_lbl 37          "NC", add
			label define stfips_lbl 38          "ND", add
			label define stfips_lbl 39          "OH", add
			label define stfips_lbl 40          "OK", add
			label define stfips_lbl 41          "OR", add
			label define stfips_lbl 42          "PA", add
			label define stfips_lbl 44          "RI", add
			label define stfips_lbl 45          "SC", add
			label define stfips_lbl 46          "SD", add			
			label define stfips_lbl 47          "TN", add
			label define stfips_lbl 48          "TX", add
			label define stfips_lbl 49          "UT", add
			label define stfips_lbl 50          "VT", add
			label define stfips_lbl 51          "VA", add
			label define stfips_lbl 53          "WA", add
			label define stfips_lbl 54          "WV", add
			label define stfips_lbl 55          "WI", add
			label define stfips_lbl 56          "WY", add
			label values stfips stfips_lbl	
			
			drop state
		}
		else if (`t'>=89) {
			gen  lstate= lfsr89
			drop if inlist(lstate, 5, 6, 7)	| lstate==.							/* omit NILF*/
			egen emp = anymatch(lstate), v(1/2)
			egen ump = anymatch(lstate), v(3/4)
			gen  ump_fl = .
			gen  ump_pt = .
			replace ump_fl = 0 if ump == 1
			replace ump_pt = 0 if ump == 1
			replace ump_fl = 1 if ump == 1 & ftpt89 == 6					/* Unemployed full-time*/
			replace ump_pt = 1 if ump == 1 & ftpt89 == 7					/* Unemployed part-time*/
			gen l2fp =.
			replace l2fp = 1 if inlist(ftpt89, 2, 3) & lstate == 2
			replace l2fp = 2 if inlist(ftpt89, 4, 5) & lstate == 2
			drop lfsr89  ftpt89
		}			

		gen self=.
		replace self = 1  if class == 5 | class == 6 | class == 7         /* omit self-employed*/
		drop class 
	}
	save `current_data'\data`t', replace
}

forvalues t = 94/99 {
	quietly use `current_data'\morg`t'.dta , clear
	keep minsamp  weight earnwt year intmonth age race sex marital stfips grade92 lfsr94 class94 hourslw uhourse earnwke ftpt94 dind docc80
	quietly{	
		gen  edu = .
		replace  edu = 0 if grade92 <= 38
		replace  edu = 1 if grade92 >= 39
		replace  edu = 2 if grade92 >= 41
		drop grade92

		gen  lstate= lfsr94
		drop if inlist(lstate, 5, 6, 7)	| lstate==.						/* omit NILF*/
		egen emp = anymatch(lstate), v(1/2)
		egen ump = anymatch(lstate), v(3/4)
		gen  ump_fl = .
		gen  ump_pt = .
		replace ump_fl = 0 if ump == 1
		replace ump_pt = 0 if ump == 1
		replace ump_fl = 1 if ump == 1 & ftpt94 == 11					/* Unemployed full-time*/
		replace ump_pt = 1 if ump == 1 & ftpt94 == 12					/* Unemployed part-time*/
		gen l2fp =.
		replace l2fp = 1 if inlist(ftpt94, 5) & lstate == 2
		replace l2fp = 2 if inlist(ftpt94, 10) & lstate == 2

		gen self = 1 if class94 == 6 | class94 == 7 | class94 == 8
		drop lfsr94 class94 ftpt94 
	}
	save `current_data'\data`t', replace
}

forvalues t = 0/18 {
	quietly use `current_data'\morg`t'.dta , clear
	keep minsamp  weight earnwt year intmonth age race sex marital stfips grade92 lfsr94 class94 hourslw uhourse earnwke ftpt94 dind02 docc00
	quietly{
		gen  edu = .
		replace  edu = 0 if grade92 <= 38
		replace  edu = 1 if grade92 >= 39
		replace  edu = 2 if grade92 >= 41
		drop grade92
	
		gen  lstate= lfsr94
		drop if inlist(lstate, 5, 6, 7)| lstate==.							/* omit NILF*/
		egen emp = anymatch(lstate), v(1/2)
		egen ump = anymatch(lstate), v(3/4)
		gen  ump_fl = .
		gen  ump_pt = .
		replace ump_fl = 0 if ump == 1
		replace ump_pt = 0 if ump == 1
		replace ump_fl = 1 if ump == 1 & ftpt94 == 11					/* Unemployed full-time*/
		replace ump_pt = 1 if ump == 1 & ftpt94 == 12					/* Unemployed part-time*/
		gen l2fp =.
		replace l2fp = 1 if inlist(ftpt94, 5) & lstate == 2
		replace l2fp = 2 if inlist(ftpt94, 10) & lstate == 2

		gen self = 1 if class94 == 6 | class94 == 7 | class94 == 8
		drop lfsr94 class94  ftpt94 
	}
	save `current_data'\data`t', replace
}
	

quietly use `current_data'\data79, clear
forvalues t = 80/99 {
	append using `current_data'\data`t'
}
forvalues t = 0/18 {
	append using `current_data'\data`t'
}
quietly{
	drop if self ==1 
	replace uhourse = hourslw if uhourse == . | uhourse == 0
	label define edu_class 0 "Less High" 1 "High school" 2 "College" 
	label values edu edu_class
	label define l2ftpt 1 "Full" 2 "Part" 
	label values l2fp l2ftpt
	replace race = 3 if race >=3
	gen survey=ym(year,intmonth)
	format survey %tm

	gen lst = .
	replace uhourse = -1 if uhourse == . 
	replace lst = 1 if (uhourse >= 35 & (lstate == 1 |  lstate == 2)) 
	replace lst = 2 if (uhourse < 35 & uhourse > 0) & (lstate == 1 |  lstate == 2)  
	replace lst = 1 if lst == . &  l2fp == 1
	replace lst = 2 if lst == . &  l2fp == 2
	replace lst = 3 if ump_fl == 1
	replace lst = 4 if ump_pt == 1

	replace uhourse = . if uhourse <= -1 

	order survey, first
	order l2fp, after(uhourse) 
	order lstate, after(year)
	order lst, after(lstate)
}
merge m:1 survey using CPImonth.dta
quietly drop _merg 
gen real_hrswg = (earnwke/uhourse)*(1/cpi) 

quietly save cps_hour_wage.dta, replace

by survey, sort: egen sum_earnwt=sum(earnwt)
gen earnwt_n = earnwt/sum_earnwt

preserve
collapse (count) N = ump (sum) ump_sum = ump ump_fl_sum = ump_fl ump_pt_sum = ump_pt [pweight=weight], by(survey)
quietly {
	gen ump_rate =  ump_sum/ N
	gen ump_fl_rate = ump_fl_sum/ N
	gen ump_pt_rate = ump_pt_sum/ N
	save `current_data'\collapsed_ump.dta, replace
}
restore

quietly {
	gen fp_state =.
	replace fp_state = 1 if lst == 2
	replace fp_state = 2 if lst == 1
	replace fp_state = 0 if inlist(lst, 3, 4)
	egen fe = anymatch(fp_state), v(2)
	egen pe = anymatch(fp_state), v(1)
	egen we = anymatch(fp_state), v(1/2)
}
preserve
	collapse (sum) sum_fulltime_e = fe  (sum) sum_parttime_e = pe  (sum) sum_worker = we [pweight=weight], by(survey)
	save `current_data'\collapsed_emp.dta, replace
restore


svyset [pweight=weight]
quietly {
	gen hour_wage_real = .
	gen hour_wage_full_real=.
	gen hour_wage_part_real=.
	replace hour_wage_real = (earnwke/uhourse)*(1/cpi) if (uhourse > 0 & uhourse < 99) 
	replace hour_wage_full_real = (earnwke/uhourse)*(1/cpi) if fp_state == 2 & (uhourse > 0 & uhourse < 99) 
	replace hour_wage_part_real = (earnwke/uhourse)*(1/cpi) if fp_state == 1 & (uhourse > 0 & uhourse < 99) 
	replace hour_wage_real =. if hour_wage_real <1 | hour_wage_real >30
	replace hour_wage_full_real =. if hour_wage_full_real <1 | hour_wage_full_real >30
	replace hour_wage_part_real =. if hour_wage_part_real <1 | hour_wage_part_real >30
	sum hour_wage_real, d

	gen weekly_wage = .
	replace weekly_wage = (earnwke/cpi) if (uhourse > 0 & uhourse < 99) 
	gen weekly_wage_full = (earnwke/cpi) if fp_state == 2 & (uhourse > 0 & uhourse < 99) 
	gen weekly_wage_part = (earnwke/cpi) if fp_state == 1 & (uhourse > 0 & uhourse < 99)

	gen fl_hour = .
	replace fl_hour = uhourse if fp_state == 2 
	gen pt_hour = .
	replace pt_hour = uhourse if fp_state == 1
	gen hour = .
	replace hour = uhourse if inlist(fp_state, 1,2)
}

tabstat fl_hour  pt_hour [aw=weight], statistics(mean median) by(survey) longstub

preserve
collapse (mean) mean_hw = hour_wage_real  (mean) mean_hw_full = hour_wage_full_real (mean) mean_hw_part = hour_wage_part_real /*
		*/(median) med_hw = hour_wage_real (median) med_hw_full = hour_wage_full_real (median) med_hw_part = hour_wage_part_real /*
		*/(median) med_week_e_full = weekly_wage_full (median) med_week_e_part = weekly_wage_part /*
		*/(p10) p10_hw=hour_wage_real (median) p50_hw=hour_wage_real (p90) p90_hw=hour_wage_real  /*
		*/(mean) hour_all = hour (median) p50_hour_all = hour /*
		*/(mean) mean_fl_hour = fl_hour (median) p50_fl_hour = fl_hour /*
		*/(mean) mean_pt_hour = pt_hour (median) p50_pt_hour = pt_hour [pweight=weight], by(survey)
*list


merge m:1 survey using `current_data'\collapsed_ump.dta
quietly drop _merg
merge m:1 survey using `current_data'\collapsed_emp.dta
quietly drop _merg

gen fe_share =  sum_fulltime_e/sum_worker
gen pe_share =  sum_parttime_e/sum_worker
gen emp_rate = 1 - ump_fl_rate - ump_pt_rate
gen emp_fl_share =  emp_rate*fe_share
gen emp_pt_share =  emp_rate*pe_share
sum emp_fl_share
sum emp_pt_share
sum ump_fl_rate
sum ump_pt_rate
gen added = emp_fl_share + emp_pt_share + ump_fl_rate + ump_pt_rate

gen wage_gap_mean = mean_hw_full / mean_hw_part
gen wage_gap_med = med_hw_full / med_hw_part
gen hour_ratio = mean_pt_hour/mean_fl_hour
gen ratio_nf_uf = (sum_fulltime_e/sum_worker)/ump_fl_rate
gen ratio_np_up = (sum_parttime_e/sum_worker)/ump_pt_rate
sum hour_ratio
sum ratio_nf_uf
sum ratio_np_up

forvalues t = 10(40)90{
	gen norm_p`t'_2 = 0
	replace norm_p`t'_2 = p`t'_hw if survey == 240
	egen norm_p`t' = max(norm_p`t'_2)
	drop norm_p`t'_2
	gen p`t'_to198001 = p`t'_hw/norm_p`t'
	label variable p`t'_to198001 "`t'th percentile: 1980/01=1"
}

tsset survey, monthly
quietly save collapsed.dta, replace
outsheet using `current'\CSV_file\collapsed.csv, comma replace

*line  survey,  yaxis(1 2) xaxis(1 2)
twoway (line med_hw_full   survey, lpattern(solid) lwidth(medthick))  (line med_hw_part survey, lpattern(solid) lwidth(medthick))  (line med_hw survey, lpattern(solid) lwidth(medthick)) , graphregion(color(white)) 
graph export `current_figure'\median_wage.png, as(png) replace

twoway (line mean_hw_full   survey, lpattern(solid) lwidth(medthick))  (line mean_hw_part survey, lpattern(solid) lwidth(medthick))  (line mean_hw survey, lpattern(solid) lwidth(medthick)) , graphregion(color(white)) 
graph export `current_figure'\mean_wage.png, as(png) replace

twoway (line mean_hw survey, lpattern(solid) lwidth(medthick)) (line med_hw survey, lpattern(solid) lwidth(medthick)) , graphregion(color(white)) 
graph export `current_figure'\med_mean_wage.png, as(png) replace

twoway (line med_week_e_full   survey, lpattern(solid) lwidth(medthick))  (line med_week_e_part survey, lpattern(solid) lwidth(medthick)), graphregion(color(white)) 
graph export `current_figure'\median_wage_weekly.png, as(png) replace

twoway (line p10_to198001 survey, lpattern(solid) lwidth(thick)) (line p50_to198001  survey, lpattern(dash) lwidth(thick))  /*
*/(line p90_to198001 survey,lpattern(shortdash) lwidth(thick)), graphregion(color(white))
graph export `current_figure'\percentile_wage.png, as(png) replace

twoway (line wage_gap_mean survey, lpattern(solid) lwidth(medthick)) (line wage_gap_med survey, lpattern(solid) lwidth(medthick)), graphregion(color(white))
graph export `current_figure'\wage_gap.png, as(png) replace

twoway (line sum_fulltime_e  survey, lwidth(medthick)) (line sum_parttime_e  survey, lwidth(medthick)) (line sum_worker  survey, lwidth(medthick)), graphregion(color(white))
graph export `current_figure'\workers.png, as(png) replace  

twoway (line fe_share  survey, lwidth(medthick)) (line pe_share  survey, lwidth(medthick)), graphregion(color(white))
graph export `current_figure'\workers_share.png, as(png) replace

twoway (line mean_fl_hour  survey, lwidth(medthick)) (line mean_pt_hour survey, lwidth(medthick))  (line hour_all survey, lwidth(medthick)), graphregion(color(white))
graph export `current_figure'\hours_worked.png, as(png) replace

twoway (line ump_rate ump_fl_rate ump_pt_rate  survey, lwidth(medthick)), graphregion(color(white))
graph export `current_figure'\ump_rate.png, as(png) replace

twoway (line emp_fl_share survey, lwidth(medthick))  (line emp_pt_share survey, lwidth(medthick)) /*
*/ (line ump_fl_rate  survey, lwidth(medthick))  (line ump_pt_rate survey, lwidth(medthick)) /*
*/ (line added survey, lwidth(medthick)), graphregion(color(white))
graph export `current_figure'\each_state.png, as(png) replace

cd `current'\CSV_file
quietly keep survey med_hw_full  med_hw_part mean_hw_full mean_hw_part hour_ratio  emp_fl_share  emp_pt_share  ump_fl_rate  ump_pt_rate
outsheet using wage_hour_flow.csv, comma replace
export excel using wage_hour_flow, replace

quietly {
	gen log_med_rhw_full = log(med_hw_full)
	gen log_med_rhw_part = log(med_hw_part)
	gen log_mean_rhw_full = log(mean_hw_full)
	gen log_mean_rhw_part = log(mean_hw_part)
}

quietly keep survey log_med_rhw_full log_med_rhw_part  log_mean_rhw_full log_mean_rhw_part
outsheet using log_wage.csv, comma replace

restore




