clc;
close all

%% declare endogenous variables
var
lambdaf yf yf_ful yf_pat kf_ful kf_pat nf_ful nf_pat cf invf nuf xf_ful xf_pat  uf_ful uf_pat  uf
vf_ful vf_pat  sf_ful sf_pat kpf  Lamf rrf rkf qkf  pwf_ful pwf_pat wf_ful wf_pat  bf 
rhof_ful Jf_ful  Jf_pat  H_xf_ful  H_xf_pat
lambda y y_ful y_pat  k_ful k_pat n_ful n_pat c i  nu x_ful x_pat  u_ful u_pat u
v_ful v_pat  s_ful s_pat kp e_ful e_pat Lam rn pi rk qk 
pw pw_ful pw_pat w_ful w_pat chi_ful chi_pat mu_ful mu_pat  wo_ful  wo_pat  b 
rho_ful J_ful J_pat H_x_ful H_x_pat  n_agg  w_agg n_time  hour_per_person
z_z  z_b  z_i  z_wf z_wp  z_p  z_g  z_r  z_phi
dy_obs dc_obs di_obs dw_obs  pi_obs  rn_obs  n_obs  w_fp_obs l_fp_obs
flow_EU_ful, flow_EE_ful, flow_EU_pat, flow_EE_pat,
lambda_cf y_cf y_ful_cf y_pat_cf k_ful_cf k_pat_cf n_ful_cf n_pat_cf c_cf i_cf  nu_cf x_ful_cf x_pat_cf  u_ful_cf u_pat_cf u_cf
v_ful_cf v_pat_cf s_ful_cf s_pat_cf kp_cf e_ful_cf e_pat_cf Lam_cf rn_cf pi_cf rk_cf qk_cf
pw_cf pw_ful_cf pw_pat_cf w_ful_cf w_pat_cf chi_ful_cf chi_pat_cf mu_ful_cf mu_pat_cf  wo_ful_cf  wo_pat_cf  b_cf 
J_ful_cf J_pat_cf H_x_ful_cf H_x_pat_cf;


%% declare exogenous variables
varexo  
e_z $\sigma_{z}$ (long_name='Technology'),  
e_b $\sigma_{b}$ (long_name='Intertemporal preference'),  
e_i $\sigma_{i}$ (long_name='Investment-specific technology'),    
e_p $\sigma_{p}$ (long_name='Price markup'),
e_g $\sigma_{g}$ (long_name='Government spending'),  
e_r $\sigma_{r}$  (long_name='Monetary policy'),  
e_wf $\sigma^{F}_{w}$ (long_name='Wage specific to FT work'), 
e_wp $\sigma^{P}_{w}$  (long_name='Wage specific to PT work'), 
e_phi $\sigma_{\phi}$  (long_name='Part-time job productivity');

%% declare parameters
parameters 
delta 	 	$\delta$ (long_name='rate of capital depreciation'),
alpha 	 	$\alpha$ (long_name='capital_s share of income'),  
yg    	 	$y_{g}$ (long_name='exogeneous demands over real GDP'),
xi    	 	$\xi$ (long_name='Kimball aggregator parameter'),
sigma_ful 	$\sigma^F$ (long_name='matching elasticity'),
sigma_pat 	$\sigma^P$ (long_name='matching elasticity'),
mu_b 		$\mu_b$ (long_name='relative hours worked of PT workers'),
rhoss_ful 	$\rho^{F}$ (long_name='Prob FT to FT'),
rhoss_pat 	$\rho^{P}$ (long_name='job surviving rate of PT workers'),
lam_fp		$\lambda^{FP}$  (long_name='prob with which a separated FT moves PT'),
sstar_ful 	$s^{F}$ (long_name='job finding rate of full-time workers'),
sstar_pat  	$s^{P}$ (long_name='job finding rate of part-time workers'),
varphi_ss   	$\varphi$ (long_name='promotion rate'), 
zeta 		$\zeta$ (long_name='Elasticity in retention rate'),
psinu		$\psi_{\nu}$ (long_name='Elasticity in utilization rate'),
etak		$\eta_{k}$ (long_name=' Capital adjustment cost elasticity '),
h_c		$h_c$ (long_name='Habit persistence in consumption'),
inv_varrho 	$1/\varrho$ (long_name='Product substitutability'),
eta_ful	 $\eta^{F}$	(long_name='Bargaining power: FT worker'),
eta_pat  $\eta^{P}$	(long_name='Bargaining power: PT worker'),
bb $\tilde{b}^{F}$  (long_name='Relative flow value of unemployment'),
eps_phi   $\epsilon^{\phi}$ (long_name='Relative PT labor productivity'),
theta_w_ful $\theta_{w}^{F}$ (long_name='Calvo wage parameter: FT worker'),	
theta_w_pat $\theta_{w}^{P}$ (long_name='Calvo wage parameter: PT worker'),	
theta_p  $\theta_{p}$ (long_name='Calvo price parameter'),	
iota_w   $\iota_{w}$ (long_name='Wage indexation'),
iota_p   $\iota_{p}$ (long_name='Price indexation'),
epsilon_p   $\epsilon_{p}$ (long_name='Steady state price markup'),
phipi $\phi_{\pi}$  (long_name='Taylor rule response to inflation'),
phiy  $\phi_{y}$  (long_name='Taylor rule response to output gap'),	
phir  $\phi_{r}$  (long_name='Monetary policy smoothing'),
zstar $100\log{\gamma_z}$ (long_name='Growth rate in balanced growth path'),	
rhoz  $\rho_{z}$ (long_name='Technology '),	
rhob  $\rho_{b}$ (long_name='Intertemporal preference'),
rhoi  $\rho_{i}$ (long_name='Investment-specific technology'),
rhop  $\rho_{p}$ (long_name='Price markup'),	
rhowf $\rho^{F}_{w}$ (long_name='Wage specific to FT work'),
rhor  $\rho_{r}$ (long_name='Monetary policy'),
rhog  $\rho_{g}$ (long_name='Government spending'),
rhophi$\rho_{\phi}$ (long_name=' Part-time job productivity '),
rhowp  $\rho^{P}_{w}$ (long_name='Wage specific to PT work'),
pistar $100\log{\pi}$  (long_name='Steady state inflation rate')
rnstar $100\log{r^n}$ (long_name='Steady state nominal interest rate')
C_rho_ful C_rho_pat qkss xss_ful xss_pat nss nss_ful nss_pat uss  uss_ful uss_pat   ntimess  nss_data
nf_share_ss  np_share_ss  uf_share_ss up_share_ss nf_np_ratio flow_EU_ful_ss  flow_EE_ful_ss  flow_EU_pat_ss  flow_EE_pat_ss;  


%%--  fixed value for some params---------------------------------------------------
//beta	= 0.99;
delta	= 0.025;
alpha	= 1/3;
yg	= 0.24;
xi = 10;
mu_b = 0.501;

nss_ful =  0.728316419107040;
nss_pat =  0.165330599624457;
uss_ful =  0.063777956922543; 
uss_pat = 1 - (nss_ful+nss_pat+uss_ful);

nss = nss_ful+nss_pat;
uss = 1-nss;  

rhoss_ful = 0.847050390000000;
lam_fp = 0.503662931863638;
rhoss_pat = 0.783370270000000;
sstar_ful = 0.812015728339779;
sstar_pat = 0.923467240347841;
varphi_ss = 0.460232196455451;


sigma_ful	=	0.347138018894410	;
sigma_pat	=	0.499877923522094	;

xss_ful = 1-rhoss_ful - varphi_ss*rhoss_pat*(nss_pat/nss_ful);
xss_pat = 1-(rhoss_pat*(1-varphi_ss))- lam_fp*(1-rhoss_ful)*(nss_ful/nss_pat);
C_rho_ful  = 1 -lam_fp*(1-rhoss_ful)/sstar_pat;
C_rho_pat  = 1 + varphi_ss*(sstar_pat/sstar_ful -1);
qkss = 1;

flow_EU_ful_ss=sstar_ful*uss_ful/nss_ful-(1-rhoss_ful)*(1-lam_fp); 
flow_EE_ful_ss=varphi_ss*rhoss_pat*nss_pat/nss_ful- lam_fp*(1-rhoss_ful); 
flow_EU_pat_ss=sstar_pat*uss_pat/nss_pat-(1-rhoss_pat); 
flow_EE_pat_ss=-varphi_ss*rhoss_pat+lam_fp*(1-rhoss_ful)*nss_ful/nss_pat;

%% The estimated parameters are fixed at posterior mean
psinu       	= 0.850;
etak        	= 4.350;
h_c         	= 0.72;
inv_varrho	= 0.20;
zeta		= 7.0;
eta_ful         = 0.8800;
eta_pat		= 0.66;
bb		= 0.71;
eps_phi		= 0.65;
theta_w_ful	= 0.4;
theta_w_pat	= 0.05;
theta_p		= 0.846;
iota_w		= 0.815;
iota_p 		= 0.60	;
epsilon_p	= 1.451;
phipi		= 1.906;
phiy		= 0.332;
phir		= 0.772;
zstar		= 0.37;
rnstar		= 1.29;
pistar		= 0.70;

rhoz		= 0.20	;
rhob		= 0.50	;
rhoi		= 0.80	;
rhop		= 0.50	;
rhowf		= 0.50	;
rhog		= 0.50	;
rhor		= 0.50	;
rhophi  	= 0.50	;
rhowp   	= 0.50	;

% parameters in observation equations
nss =nss_ful+nss_pat;						
nf_share_ss=nss_ful/nss;					
np_share_ss=nss_pat/nss;					
uss=uss_ful+uss_pat;						
uf_share_ss=uss_ful/uss;					
up_share_ss=uss_pat/uss;					
nf_np_ratio=nss_ful/nss_pat;					

ntimess=nss_ful+mu_b*nss_pat;
nss_data=0.764228909+0.172984622;

model(linear);
%% declare local parameters
% measurement equations
#gammaz=exp(zstar/100);            				
#gammap=exp(pistar/100);
#rnss = exp(rnstar/100);					
#beta = gammaz*(gammap/rnss);


% reparameterization  
#eps_rhoJ = 1/zeta;
#varrho=1/inv_varrho;
#htilda=h_c/gammaz; 						
#etanu=(1-psinu)/psinu;						
#betatilda = beta/gammaz; 					

% marginal cost 
#xi_ful = nss_ful/(nss_ful+eps_phi*mu_b*nss_pat);
#xi_pat = 1-xi_ful;
#pwss=1/epsilon_p;						% pwss is the steady-state value of price of intermediate good
#pwfp_ratio = ((xi_ful/(1-xi_ful))*(eps_phi*mu_b*nss_pat/nss_ful))^((1-alpha)/(varrho*(1-alpha)+alpha));
#pwss_ful=pwss*(xi_ful+(1-xi_ful)*pwfp_ratio^(varrho-1))^(1/(varrho-1));
#pwss_pat=pwss_ful*(1/pwfp_ratio);

% production optimization
#rkss = (gammaz/beta)-1+delta;  
#kss_ful = ((rkss/(alpha*pwss_ful))^(-1/(1-alpha)))*nss_ful;		 % from Capital/employment condition
#kss_pat = ((rkss/(alpha*pwss_pat))^(-1/(1-alpha)))*(eps_phi*mu_b*nss_pat);
#kss = kss_ful + kss_pat;
#ass_ful = (1-alpha)*(kss_ful/nss_ful)^alpha; 
#ass_pat = (1-alpha)*eps_phi*mu_b*(kss_pat/(eps_phi*mu_b*nss_pat))^alpha;
#yss = (1/xi_ful)*nss_ful*(kss_ful/nss_ful)^alpha;
#yf_yss = xi_ful*(pwss_ful/pwss)^(-varrho);
#yp_yss = xi_pat*(pwss_pat/pwss)^(-varrho);
#y_int_f = xi_ful^inv_varrho*yf_yss^(1-inv_varrho);
#y_int_p = xi_pat^inv_varrho*yp_yss^(1-inv_varrho);
#kyss = kss/yss;                                                 
#LX_ful = xss_ful - (xss_ful/2 + rhoss_ful/(zeta+1));

% steady state wages and workers' surplus
#muss_ful=1/(1-theta_w_ful*(xss_ful+rhoss_ful)*beta);  					
#muss_pat=mu_b/(1-theta_w_pat*beta); 
#ess_ful=(1-eta_ful)/(eta_ful*(rhoss_ful*theta_w_ful*beta)*eps_rhoJ*(1-lam_fp*sstar_ful/sstar_pat)+(1-eta_ful)*(1-(rhoss_ful*theta_w_ful*beta)));
#ess_pat=mu_b/(1-(1-xss_pat)*theta_w_pat*(1-varphi_ss)*rhoss_pat*beta);                                 	
#chiss_ful=eta_ful/(eta_ful+(1-eta_ful)*muss_ful/ess_ful);            		
#chiss_pat=eta_pat/(eta_pat+(1-eta_pat)*muss_pat/ess_pat);   			

#YY=xss_ful/2 + rhoss_ful/(zeta+1);
#zeta_ful_temp=1-beta*YY*(1-bb)*(1-chiss_ful)-beta*(rhoss_ful-sstar_ful*C_rho_ful*chiss_ful);                      
#kappa_ful=pwss_ful*ass_ful*(1-bb)*(1-chiss_ful)/(xss_ful*zeta_ful_temp);						
#wss_ful=pwss_ful*ass_ful*(bb*(1-chiss_ful)*(1-beta*rhoss_ful)-chiss_ful*(beta*rhoss_ful-beta*sstar_ful*C_rho_ful-1))/zeta_ful_temp;   	
#bss=pwss_ful*ass_ful*bb*(1-beta*(rhoss_ful-sstar_ful*C_rho_ful*chiss_ful))/zeta_ful_temp;

#kappa_pat=(sstar_ful*(1-chiss_pat)*chiss_ful)/(xss_pat*sstar_pat*chiss_pat*(1-chiss_ful))*kappa_ful*xss_ful;
#wss_pat=(1/mu_b)*(pwss_pat*ass_pat-(1-beta*(rhoss_pat*(1-varphi_ss)))*kappa_pat*xss_pat+beta*(kappa_pat/2)*(xss_pat)^2);


#H_ful = (chiss_ful/(1-chiss_ful))*kappa_ful*xss_ful;
#H_pat = (chiss_pat/(1-chiss_pat))*kappa_pat*xss_pat;

#temp0 = pwss_pat*ass_pat +beta*(kappa_pat/2)*(xss_pat)^2 + beta*(sstar_pat - rhoss_pat*(1-varphi_ss-C_rho_pat))*kappa_pat*xss_pat;
#temp1 = (1/(1-chiss_pat))*(wss_pat*mu_b - chiss_pat*temp0);
#mu_pb = (1/bss)*temp1;

% resource constraint
#yi = (1-(1-delta)/gammaz)*gammaz*kyss;
#ynu = rkss*kss_ful/yss;     
#yx_ful = (kappa_ful/2)*((xss_ful^2)*nss_ful/yss);
#yx_pat = (kappa_pat/2)*((xss_pat^2)*nss_pat/yss);
#yzeta_ful = (zeta+1)^(-1)*rhoss_ful*kappa_ful*xss_ful*nss_ful/yss;					  
#yc = 1-(yg+yi+(yx_ful+yx_pat)+ynu+yzeta_ful); 

% definitions
#wss_a_ful = wss_ful;
#wss_a_pat = wss_pat*mu_b;

% dynamic equation for JF and JP
#kappalambda_ful=beta*(LX_ful+rhoss_ful);					
#kappalambda_pat=beta*(1+(rhoss_pat*(1-varphi_ss)))/2;       				
@#for ell in [ "ful", "pat" ]
#kappaa_@{ell} = (kappa_@{ell}*xss_@{ell})^(-1)*pwss_@{ell}*ass_@{ell};
#kappaw_@{ell} = (kappa_@{ell}*xss_@{ell})^(-1)*wss_a_@{ell};   
@#endfor

% target wage functions
@#for ell in [ "ful", "pat" ]
#phia_@{ell}=chiss_@{ell}*pwss_@{ell}*ass_@{ell}*(wss_a_@{ell})^(-1);
#phix_@{ell}=chiss_@{ell}*beta*kappa_@{ell}*(xss_@{ell})^2*(wss_a_@{ell})^(-1);
#phis_@{ell}=(1-chiss_@{ell})*sstar_@{ell}*beta*H_@{ell}*(wss_a_@{ell})^(-1);
#phichi_@{ell}=chiss_@{ell}*(1-chiss_@{ell})^(-1)*kappa_@{ell}*xss_@{ell}*(wss_a_@{ell})^(-1);
@#endfor
#phib_ful=(1-chiss_ful)*bss*wss_ful^(-1);   				
#phib_pat=(1-chiss_pat)*(mu_pb*bss)*(wss_pat*mu_b)^(-1);  
#phiLX_ful=chiss_ful*beta*kappa_ful*xss_ful*LX_ful*wss_ful^(-1);         	
#phis_phi=(1-chiss_pat)*varphi_ss*rhoss_pat*beta*H_ful*(wss_pat*mu_b)^(-1);
#phieta_ful=(phichi_ful*(1-chiss_ful)*(1-eta_ful)^(-1))*(1-(rhoss_ful-sstar_ful)*beta*rhowf); %%%%%
#phieta_pat=phichi_pat*(1-(1-xss_pat-sstar_pat)*beta*rhowp); 
#phihatrho_ful=(1-chiss_ful)*beta*(H_pat/wss_ful)*lam_fp*(1-rhoss_ful);
#phirho_ful = (1-chiss_ful)*beta*((H_ful-lam_fp*H_pat)/wss_ful)*rhoss_ful*eps_rhoJ;
#m_ful_zero=xss_ful+rhoss_ful*eps_rhoJ;
#e_ful_zero=(1/ess_ful)*muss_ful*eps_rhoJ*((H_ful- lam_fp*H_pat)/(kappa_ful*xss_ful));
#hat_ess_ful = ess_ful-muss_ful*eps_rhoJ*((H_ful-lam_fp*H_pat)/(kappa_ful*xss_ful));
#Big_Theta_ful=-(rhoss_ful*beta*theta_w_ful)*(kappaw_ful*muss_ful)*((2-e_ful_zero)*eps_rhoJ+e_ful_zero-e_ful_zero*(m_ful_zero*beta*theta_w_ful)*muss_ful);

% dynamic wage functions
#psi_ful=chiss_ful*beta*theta_w_ful*muss_ful+(1-chiss_ful)*(1-xss_ful)*beta*theta_w_ful*hat_ess_ful;		
#psi_pat=chiss_pat*beta*theta_w_pat*muss_pat+(1-chiss_pat)*(1-xss_pat)*beta*theta_w_pat*ess_pat;	
@#for ell in [ "ful", "pat" ]
#tau_@{ell}=psi_@{ell}/(1+psi_@{ell});							
#varsigma_@{ell}=(1-theta_w_@{ell})*(1-tau_@{ell})*theta_w_@{ell}^(-1); 
@#endfor						
#G_ful=(1-eta_ful*(m_ful_zero*beta*theta_w_ful)*muss_ful)*eta_ful^(-1)*muss_ful*kappaw_ful - ess_ful*Big_Theta_ful;
#G_ful_cf=(1-eta_ful*(xss_ful*beta*theta_w_ful)*muss_ful)*eta_ful^(-1)*muss_ful*kappaw_ful;
#G_pat=(1-eta_pat*(xss_pat*beta*theta_w_pat)*muss_pat)*eta_pat^(-1)*muss_pat*kappaw_pat;     	
#tau1_ful=(kappaw_ful*muss_ful*(phix_ful-phirho_ful)+phichi_ful*(rhoss_ful*beta)*(1-chiss_ful)*(ess_ful*Big_Theta_ful+(m_ful_zero*beta*theta_w_ful)*(kappaw_ful*muss_ful)*muss_ful)+phis_ful*G_ful)*(1-tau_ful);	%%%%%
#tau1_ful_cf=(kappaw_ful*muss_ful*phix_ful+phichi_ful*(rhoss_ful*beta)*(1-chiss_ful)*(xss_ful*beta*theta_w_ful)*(kappaw_ful*muss_ful)*muss_ful+phis_ful*G_ful_cf)*(1-tau_ful);
#tau1_pat=(kappaw_pat*muss_pat*phix_pat+phichi_pat*((1-xss_pat)*beta)*(1-chiss_pat)*(xss_pat*beta*theta_w_pat)*(kappaw_pat*muss_pat)*muss_pat+phis_pat*G_pat)*(1-tau_pat);	
#tau2_ful=-(kappaw_ful*muss_ful)*phichi_ful*(1-chiss_ful)*(ess_ful*Big_Theta_ful +(m_ful_zero*beta*theta_w_ful)*muss_ful*(1-tau_ful));	
#tau2_ful_cf=-(kappaw_ful*muss_ful)*phichi_ful*(1-chiss_ful)*(xss_ful*beta*theta_w_ful)*muss_ful*(1-tau_ful);		
#tau2_pat=-(kappaw_pat*muss_pat)*phichi_pat*(1-chiss_pat)*(xss_pat*beta*theta_w_pat)*muss_pat*(1-tau_pat);
@#for ell in [ "ful", "pat" ]
#Phi_@{ell}=(1+tau2_@{ell})+varsigma_@{ell}+(tau_@{ell}*theta_w_@{ell}^(-1)-tau1_@{ell});	
#gammab_@{ell}=(1+tau2_@{ell})*Phi_@{ell}^(-1);						
#gammao_@{ell}=varsigma_@{ell}*Phi_@{ell}^(-1);						
#gammaf_@{ell}=(tau_@{ell}*theta_w_@{ell}^(-1)-tau1_@{ell})*Phi_@{ell}^(-1);		
@#endfor
#Phi_ful_cf=(1+tau2_ful_cf)+varsigma_ful+(tau_ful*theta_w_ful^(-1)-tau1_ful_cf);
#gammab_ful_cf=(1+tau2_ful_cf)*Phi_ful_cf^(-1);
#gammao_ful_cf=varsigma_ful*Phi_ful_cf^(-1);
#gammaf_ful_cf=(tau_ful*theta_w_ful^(-1)-tau1_ful_cf)*Phi_ful_cf^(-1);

% Phillips curve
#tau_p=1+(epsilon_p-1)*xi;					% shown in (C24)
#kappap=(1-theta_p)*(1-beta*theta_p)/(theta_p*tau_p);        	
#iotab=iota_p*(1+beta*iota_p)^(-1);				
#iotao=kappap*(1+beta*iota_p)^(-1);				
#iotaf=beta*(1+beta*iota_p)^(-1);				

#wss_agg=nf_share_ss*wss_ful+np_share_ss*wss_pat*mu_b;				
#wage_prem=wss_ful/wss_pat;
#log_wage_prem=log(wage_prem);
#wf_share=nf_share_ss*wss_ful/wss_agg;						
#wp_share=np_share_ss*wss_pat*mu_b/wss_agg;					

% describe model equations
% flexible price

(1-htilda)*(1-beta*htilda)*lambdaf = htilda*(cf(-1) - z_z) - (1 + beta*htilda^2)*cf 
 + beta*htilda*(cf(+1) + z_z(+1)) + (1-htilda)*(z_b - beta*htilda*z_b(+1));

0 = Lamf - z_z(+1) + rrf;  

Lamf =  lambdaf(+1) - lambdaf;

kpf = ((1-delta)/gammaz)*(kpf(-1)-z_z) + (1-(1-delta)/gammaz)*(invf+z_i);

(kss_ful/kss)*kf_ful +  (kss_pat/kss)*kf_pat + z_z - nuf - kpf(-1) = 0;

nuf = etanu*rkf;

qkf = betatilda*(1-delta)*qkf(+1) + (1-betatilda*(1-delta))*rkf(+1) - rrf;

invf = (1/(1+beta))*(invf(-1)-z_z) + ((1/(etak*gammaz^2))/(1+beta))*(qkf+z_i) + (beta/(1+beta))*(invf(+1)+z_z(+1));

yf_ful =  alpha*kf_ful + (1-alpha)*nf_ful;
yf_pat =  alpha*kf_pat + (1-alpha)*(nf_pat + z_phi);

yf = y_int_f *yf_ful + y_int_p*yf_pat;

0 = (xi_ful*(pwss_ful/pwss)^(1-varrho))*pwf_ful + (xi_pat*(pwss_pat/pwss)^(1-varrho))*pwf_pat;

yf_pat - yf_ful = - varrho*(pwf_pat - pwf_ful);

rkf = pwf_ful +  yf_ful - kf_ful;
rkf = pwf_pat +  yf_pat - kf_pat;


rhof_ful =  eps_rhoJ*Jf_ful;

nf_ful = (rhoss_ful + xss_ful)*nf_ful(-1) + xss_ful*xf_ful(-1) + rhoss_ful*rhof_ful + (1-(rhoss_ful + xss_ful))*nf_pat(-1);

nf_pat =  (rhoss_pat*(1-varphi_ss) + xss_pat)*nf_pat(-1) + xss_pat*xf_pat(-1) + lam_fp*(1-rhoss_ful)*(nss_ful/nss_pat)*nf_ful(-1) - lam_fp*(nss_ful/nss_pat)*rhoss_ful*rhof_ful;

uf = -(nss_ful/uss)*nf_ful-(nss_pat/uss)*nf_pat;

sf_ful + H_xf_ful(+1) = sf_pat  +  H_xf_pat(+1);

uss_pat*uf_pat + uss_ful*uf_ful + nss_ful*nf_ful + nss_pat*nf_pat =0;

sf_ful = (1-sigma_ful)*(vf_ful - uf_ful);
sf_pat = (1-sigma_pat)*(vf_pat - uf_pat);

bf = kpf;

xf_ful = sf_ful + uf_ful - nf_ful;
xf_pat = sf_pat + uf_pat - nf_pat;

Jf_ful = kappaa_ful*(pwf_ful + (yf_ful - nf_ful)) - kappaw_ful*wf_ful + kappalambda_ful*Lamf  +  (beta+rhoss_ful*eps_rhoJ)*Jf_ful(+1);
xf_ful = Jf_ful(+1);

Jf_pat = kappaa_pat*(pwf_pat+(yf_pat - nf_pat)) - kappaw_pat*wf_pat + kappalambda_pat*Lamf + beta*Jf_pat(+1);
xf_pat = Jf_pat(+1);

wf_ful = phia_ful*(pwf_ful + (yf_ful - nf_ful)) + (phix_ful + phis_ful)*Jf_ful(+1) + phis_ful*sf_ful + phib_ful*bf + (phis_ful-phihatrho_ful+phiLX_ful)*Lamf  -phihatrho_ful*H_xf_pat(+1)  + z_wf;
wf_pat = phia_pat*(pwf_pat + (yf_pat - nf_pat)) + (phix_pat + phis_pat)*Jf_pat(+1) + phis_pat*sf_pat + phib_pat*bf + (phis_pat-phis_phi+phix_pat/2)*Lamf - phis_phi*H_xf_ful(+1) + z_wp;

H_xf_ful =  xf_ful + (1-eta_ful)^(-1)*phieta_ful^(-1)*z_wf;
H_xf_pat =  xf_pat + (1-eta_pat)^(-1)*phieta_pat^(-1)*z_wp;

yf = yc*cf + yi*invf + yg*(yf+((1-yg)/yg)*z_g) + ynu*nuf + yx_ful*(2*xf_ful(-1)+nf_ful(-1)) + yx_pat*(2*xf_pat(-1)+nf_pat(-1))+yzeta_ful*nf_ful(-1);  


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% sticky price
//Marginal utility of consumption
(1-htilda)*(1-beta*htilda)*lambda = htilda*(c(-1)-z_z) - (1+beta*htilda^2)*c 
+ beta*htilda*(c(+1)+z_z(+1)) + (1-htilda)*(z_b-beta*htilda*z_b(+1));           

//Euler equation
Lam - z_z(+1) + rn - pi(+1) = 0; 

//Stchastic discount factor
Lam  =  lambda(+1) - lambda;

//Physical capital accumulation
kp = ((1-delta)/gammaz)*(kp(-1)-z_z) +(1-(1-delta)/gammaz)*(i+z_i);

//Effective capital
(kss_ful/kss)*k_ful +  (kss_pat/kss)*k_pat + z_z = nu + kp(-1);

// capital utilization
nu = etanu*rk;

// tobin's q    
qk = betatilda*(1-delta)*qk(+1) + (1-betatilda*(1-delta))*rk(+1) - (rn-pi(+1));

// investment
i = (1/(1+beta))*(i(-1)-z_z) + ((1/(etak*gammaz^2))/(1+beta))*(qk+z_i) + (beta/(1+beta))*(i(+1)+z_z(+1));

// production function
y_ful =  alpha*k_ful + (1-alpha)*n_ful;
y_pat =  alpha*k_pat + (1-alpha)*(n_pat + z_phi);

y = y_int_f *y_ful + y_int_p*y_pat;

// marginal cost
pw = (xi_ful*(pwss_ful/pwss)^(1-varrho))*pw_ful + (xi_pat*(pwss_pat/pwss)^(1-varrho))*pw_pat;
y_pat - y_ful = - varrho*(pw_pat - pw_ful);

// MPK
rk = pw_ful +  y_ful - k_ful;
rk = pw_pat +  y_pat - k_pat;


//Retension reta
rho_ful =  eps_rhoJ*J_ful;


//Employment dynamics
n_ful = (rhoss_ful + xss_ful)*n_ful(-1) + xss_ful*x_ful(-1) + rhoss_ful*rho_ful + (1-(rhoss_ful + xss_ful))*n_pat(-1);
n_pat = (rhoss_pat*(1-varphi_ss) + xss_pat)*n_pat(-1) + xss_pat*x_pat(-1) + lam_fp*(1-rhoss_ful)*(nss_ful/nss_pat)*n_ful(-1) - lam_fp*(nss_ful/nss_pat)*rhoss_ful*rho_ful;


//Unemployment
u = -(nss_ful/uss)*n_ful-(nss_pat/uss)*n_pat;

s_ful + H_x_ful(+1) = s_pat  +  H_x_pat(+1);

uss_pat*u_pat + uss_ful*u_ful + nss_ful*n_ful + nss_pat*n_pat =0;


//Probability with which a searching unemployed workers gets a job
s_ful = (1-sigma_ful)*(v_ful - u_ful);
s_pat = (1-sigma_pat)*(v_pat - u_pat);


//Unemploymest insurance
b = kp;

//Hiring rate
x_ful = s_ful + u_ful - n_ful;
x_pat = s_pat + u_pat - n_pat;

//Aggregate hiring rate 
J_ful = kappaa_ful*(pw_ful+(y_ful - n_ful)) - kappaw_ful*w_ful + kappalambda_ful*Lam + (beta+rhoss_ful*eps_rhoJ)*J_ful(+1);
x_ful = J_ful(+1);

J_pat = kappaa_pat*(pw_pat+(y_pat - n_pat)) - kappaw_pat*w_pat + kappalambda_pat*Lam + beta*J_pat(+1);
x_pat = J_pat(+1);

//Weight in Nash bargaining
chi_ful + (1-chiss_ful)*mu_ful -(1-chiss_ful)*e_ful =0;

e_ful = (rhoss_ful*theta_w_ful*beta)*(1-e_ful_zero)*(Lam-pi(+1) + iota_w*pi + e_ful(+1) - z_z(+1))
-(rhoss_ful*theta_w_ful*beta)*e_ful_zero*mu_ful(+1)
+(rhoss_ful*theta_w_ful*beta)*((1-e_ful_zero)*eps_rhoJ+e_ful_zero)*J_ful(+1)
+ess_ful*Big_Theta_ful*(w_ful+iota_w*pi-pi(+1)-z_z(+1)-w_ful(+1))
-(rhoss_ful*theta_w_ful*beta)*e_ful_zero*(H_ful-lam_fp*H_pat)^(-1)*(H_ful*H_x_ful(+1)- lam_fp*H_pat*H_x_pat(+1));


mu_ful = (m_ful_zero*theta_w_ful*beta)*J_ful(+1) 
-(m_ful_zero*theta_w_ful*beta)*kappaw_ful*(muss_ful^2)*(w_ful+iota_w*pi-pi(+1)-z_z(+1)-w_ful(+1))
+(theta_w_ful*beta)*(mu_ful(+1)+Lam+iota_w*pi-pi(+1)-z_z(+1));

chi_pat + (1-chiss_pat)*mu_pat -(1-chiss_pat)*e_pat =0;

e_pat = ((rhoss_pat*(1-varphi_ss))*theta_w_pat*beta)*(Lam-pi(+1)+iota_w*pi+e_pat(+1)-z_z(+1));

mu_pat = (xss_pat*theta_w_pat*beta)*J_pat(+1) 
-(xss_pat*theta_w_pat*beta)*kappaw_pat*(muss_pat^2)*(w_pat+iota_w*pi-pi(+1)-z_z(+1)-w_pat(+1))
+(theta_w_pat*beta)*(mu_pat(+1) + Lam + iota_w*pi-pi(+1)-z_z(+1));

//Spillover free target wage  
wo_ful = phia_ful*(pw_ful + (y_ful - n_ful)) + (phis_ful+phix_ful)*J_ful(+1) + phis_ful*s_ful + phib_ful*b + (phis_ful-phihatrho_ful+phiLX_ful)*Lam  -phihatrho_ful*H_x_pat(+1)  + phichi_ful*(chi_ful-(rhoss_ful-sstar_ful)*beta*chi_ful(+1)) + z_wf;
wo_pat = phia_pat*(pw_pat + (y_pat - n_pat)) + (phis_pat+phix_pat)*J_pat(+1) + phis_pat*s_pat + phib_pat*b + (phis_pat-phis_phi+phix_pat/2)*Lam  - phis_phi*H_x_ful(+1)  + phichi_pat*(chi_pat-(rhoss_pat-sstar_pat)*beta*chi_pat(+1)) + z_wp;

H_x_ful =  x_ful - (G_ful*theta_w_ful/(1-theta_w_ful))*(w_ful -(w_ful(-1) - pi + pi(-1) - z_z)) +(1-chiss_ful)^(-1)*chi_ful +(1-eta_ful)^(-1)*phieta_ful^(-1)*z_wf;
H_x_pat =  x_pat - (G_pat*theta_w_pat/(1-theta_w_pat))*(w_pat -(w_pat(-1) - pi + pi(-1) - z_z)) +(1-chiss_pat)^(-1)*chi_pat +(1-eta_pat)^(-1)*phieta_pat^(-1)*z_wp;

//Aggregate wage
w_ful = gammab_ful*(w_ful(-1)-pi+iota_w*pi(-1)-z_z) + gammao_ful*wo_ful +gammaf_ful*(w_ful(+1)+pi(+1)-iota_w*pi+z_z(+1));
w_pat = gammab_pat*(w_pat(-1)-pi+iota_w*pi(-1)-z_z) + gammao_pat*wo_pat +gammaf_pat*(w_pat(+1)+pi(+1)-iota_w*pi+z_z(+1));
w_agg = wf_share*(w_ful + n_ful - n_agg)  +  wp_share*(w_pat + n_pat - n_agg);

//Phillips curve
pi =iotab*pi(-1) + iotao*pw  + iotaf*pi(+1) + z_p; 

//Monetary policy
rn = phir*rn(-1) + (1-phir)*(phipi*pi+phiy*(y-yf))+z_r;


//Resource constraint
y = yc*c + yi*i + yg*(y+((1-yg)/yg)*z_g) + ynu*nu + yx_ful*(2*x_ful(-1)+n_ful(-1)) + yx_pat*(2*x_pat(-1)+n_pat(-1)) + yzeta_ful*n_ful(-1);

n_agg = nf_share_ss*n_ful + np_share_ss*n_pat;
n_time = (nss_ful/ntimess)*n_ful + (mu_b*nss_pat/ntimess)*n_pat;
hour_per_person = n_time - n_agg;

flow_EU_ful = (xss_ful/flow_EU_ful_ss)*(x_ful(-1)) + (rhoss_ful*(1-lam_fp)/flow_EU_ful_ss)*rho_ful ;
flow_EE_ful = ((varphi_ss*rhoss_pat*nss_pat/nss_ful)/flow_EE_ful_ss)*(n_pat(-1)-n_ful(-1)) + (lam_fp*rhoss_ful/flow_EE_ful_ss)*rho_ful;
flow_EU_pat = (xss_pat/flow_EU_pat_ss)*(x_pat(-1));
flow_EE_pat = ((lam_fp*nss_ful/nss_pat)/flow_EE_pat_ss)*((1-rhoss_ful)*(n_ful(-1) - n_pat(-1)) - rhoss_ful*rho_ful);




// innovation process
z_z = rhoz*z_z(-1)+e_z;			
z_b = rhob*z_b(-1)+e_b;
z_i = rhoi*z_i(-1)+e_i;
z_p = rhop*z_p(-1)+e_p;
z_wf = rhowf*z_wf(-1)+e_wf;
z_wp = rhowp*z_wp(-1)+e_wp;
z_g = rhog*z_g(-1)+e_g;
z_r = rhor*z_r(-1)+e_r;
z_phi = rhophi*z_phi(-1)+e_phi;

//measurement function
dy_obs = zstar + y - y(-1) + z_z; 
dc_obs = zstar + c - c(-1) + z_z;
di_obs = zstar + i - i(-1) + z_z;
dw_obs = zstar + w_agg - w_agg(-1) + z_z;
pi_obs = pistar + pi;
rn_obs = rnstar + rn;
n_obs  = 100*log(nss_data)  + n_agg;
w_fp_obs = 100*log_wage_prem + w_ful - w_pat;
l_fp_obs = 100*log(nf_np_ratio) + n_ful - n_pat;


% counterfactual
//Marginal utility of consumption
(1-htilda)*(1-beta*htilda)*lambda_cf = htilda*(c_cf(-1)-z_z) - (1+beta*htilda^2)*c_cf 
+ beta*htilda*(c_cf(+1)+z_z(+1)) + (1-htilda)*(z_b-beta*htilda*z_b(+1));           

//Euler equation
Lam_cf - z_z(+1) + rn_cf - pi_cf(+1) = 0; 

//Stchastic discount factor
Lam_cf  =  lambda_cf(+1) - lambda_cf;

//Physical capital accumulation
kp_cf = ((1-delta)/gammaz)*(kp_cf(-1)-z_z) +(1-(1-delta)/gammaz)*(i_cf+z_i);

//Effective capital
(kss_ful/kss)*k_ful_cf + (kss_pat/kss)*k_pat_cf + z_z = nu_cf + kp_cf(-1);

// capital utilization
nu_cf = etanu*rk_cf;

// tobin's q    
qk_cf = betatilda*(1-delta)*qk_cf(+1) + (1-betatilda*(1-delta))*rk_cf(+1) - (rn_cf-pi_cf(+1));

// investment
i_cf = (1/(1+beta))*(i_cf(-1)-z_z) + ((1/(etak*gammaz^2))/(1+beta))*(qk_cf+z_i) + (beta/(1+beta))*(i_cf(+1)+z_z(+1));

// production function
y_ful_cf =  alpha*k_ful_cf + (1-alpha)*n_ful_cf;
y_pat_cf =  alpha*k_pat_cf + (1-alpha)*(n_pat_cf + z_phi);

y_cf = y_int_f *y_ful_cf + y_int_p*y_pat_cf;

// marginal cost
pw_cf = (xi_ful*(pwss_ful/pwss)^(1-varrho))*pw_ful_cf + (xi_pat*(pwss_pat/pwss)^(1-varrho))*pw_pat_cf;
y_pat_cf - y_ful_cf = - varrho*(pw_pat_cf - pw_ful_cf);

// MPK
rk_cf = pw_ful_cf +  y_ful_cf - k_ful_cf;
rk_cf = pw_pat_cf +  y_pat_cf - k_pat_cf;


//Employment dynamics
n_ful_cf = (rhoss_ful + xss_ful)*n_ful_cf(-1) + xss_ful*x_ful_cf(-1) + (1-(rhoss_ful + xss_ful))*n_pat_cf(-1);
n_pat_cf = (rhoss_pat*(1-varphi_ss) + xss_pat)*n_pat_cf(-1) + xss_pat*x_pat_cf(-1) + lam_fp*(1-rhoss_ful)*(nss_ful/nss_pat)*n_ful_cf(-1);

//Unemployment
u_cf = -(nss_ful/uss)*n_ful_cf-(nss_pat/uss)*n_pat_cf;
s_ful_cf + H_x_ful_cf(+1) = s_pat_cf  +  H_x_pat_cf(+1);

uss_pat*u_pat_cf + uss_ful*u_ful_cf + nss_ful*n_ful_cf + nss_pat*n_pat_cf =0;


//Probability with which a searching unemployed workers gets a job
s_ful_cf = (1-sigma_ful)*(v_ful_cf - u_ful_cf);
s_pat_cf = (1-sigma_pat)*(v_pat_cf - u_pat_cf);


//Unemploymest insurance
b_cf = kp_cf;

//Aggregate vacancies
x_ful_cf = s_ful_cf + u_ful_cf - n_ful_cf;
x_pat_cf = s_pat_cf + u_pat_cf - n_pat_cf;

//Aggregate hiring rate 
J_ful_cf = kappaa_ful*(pw_ful_cf+(y_ful_cf - n_ful_cf)) - kappaw_ful*w_ful_cf + kappalambda_ful*Lam_cf + beta*J_ful_cf(+1);
x_ful_cf = J_ful_cf(+1);

J_pat_cf = kappaa_pat*(pw_pat_cf+(y_pat_cf - n_pat_cf)) - kappaw_pat*w_pat_cf + kappalambda_pat*Lam_cf + beta*J_pat_cf(+1);
x_pat_cf = J_pat_cf(+1);


//Weight in Nash bargaining
chi_ful_cf + (1-chiss_ful)*mu_ful_cf -(1-chiss_ful)*e_ful_cf =0;

e_ful_cf = (rhoss_ful*theta_w_ful*beta)*(Lam_cf-pi_cf(+1) + iota_w*pi_cf + e_ful_cf(+1) - z_z(+1));

mu_ful_cf = (xss_ful*theta_w_ful*beta)*J_ful_cf(+1) 
-(xss_ful*theta_w_ful*beta)*kappaw_ful*(muss_ful^2)*(w_ful_cf+iota_w*pi_cf-pi_cf(+1)-z_z(+1)-w_ful_cf(+1))
+(theta_w_ful*beta)*(mu_ful_cf(+1)+Lam_cf+iota_w*pi_cf-pi_cf(+1)-z_z(+1));

chi_pat_cf + (1-chiss_pat)*mu_pat_cf -(1-chiss_pat)*e_pat_cf =0;

e_pat_cf = ((rhoss_pat*(1-varphi_ss))*theta_w_pat*beta)*(Lam_cf-pi_cf(+1)+iota_w*pi_cf+e_pat_cf(+1)-z_z(+1));

mu_pat_cf = (xss_pat*theta_w_pat*beta)*J_pat_cf(+1) 
-(xss_pat*theta_w_pat*beta)*kappaw_pat*(muss_pat^2)*(w_pat_cf+iota_w*pi_cf-pi_cf(+1)-z_z(+1)-w_pat_cf(+1))
+(theta_w_pat*beta)*(mu_pat_cf(+1) + Lam_cf+iota_w*pi_cf-pi_cf(+1)-z_z(+1));

//Spillover free target wage  
wo_ful_cf = phia_ful*(pw_ful_cf + (y_ful_cf - n_ful_cf)) + (phis_ful+phix_ful-phirho_ful)*J_ful_cf(+1) + phis_ful*s_ful_cf + phib_ful*b_cf + (phis_ful-phihatrho_ful+phix_ful/2)*Lam_cf  -phihatrho_ful*H_x_pat_cf(+1)  + phichi_ful*(chi_ful_cf-(rhoss_ful-sstar_ful)*beta*chi_ful_cf(+1)) + z_wf;
wo_pat_cf = phia_pat*(pw_pat_cf + (y_pat_cf - n_pat_cf)) + (phis_pat+phix_pat)*J_pat_cf(+1) + phis_pat*s_pat_cf + phib_pat*b_cf + (phis_pat-phis_phi+phix_pat/2)*Lam_cf  - phis_phi*H_x_ful_cf(+1)  + phichi_pat*(chi_pat_cf-(rhoss_pat-sstar_pat)*beta*chi_pat_cf(+1)) + z_wp;

H_x_ful_cf =  x_ful_cf - (G_ful*theta_w_ful/(1-theta_w_ful))*(w_ful_cf -(w_ful_cf(-1) - pi_cf + pi_cf(-1) - z_z)) +(1-chiss_ful)^(-1)*chi_ful_cf +(1-eta_ful)^(-1)*phieta_ful^(-1)*z_wf;
H_x_pat_cf =  x_pat_cf - (G_pat*theta_w_pat/(1-theta_w_pat))*(w_pat_cf -(w_pat_cf(-1) - pi_cf + pi_cf(-1) - z_z)) +(1-chiss_pat)^(-1)*chi_pat_cf +(1-eta_pat)^(-1)*phieta_pat^(-1)*z_wp;

//Aggregate wage
w_ful_cf = gammab_ful_cf*(w_ful_cf(-1)-pi_cf+iota_w*pi_cf(-1)-z_z) + gammao_ful_cf*wo_ful_cf +gammaf_ful_cf*(w_ful_cf(+1)+pi_cf(+1)-iota_w*pi_cf+z_z(+1));
w_pat_cf = gammab_pat*(w_pat_cf(-1)-pi_cf+iota_w*pi_cf(-1)-z_z) + gammao_pat*wo_pat_cf +gammaf_pat*(w_pat_cf(+1)+pi_cf(+1)-iota_w*pi_cf+z_z(+1));

//Phillips curve
pi_cf =iotab*pi_cf(-1) + iotao*pw_cf  + iotaf*pi_cf(+1) + z_p; 

//Monetary policy
rn_cf = phir*rn_cf(-1) + (1-phir)*(phipi*pi_cf+phiy*(y_cf-yf))+z_r;


//Resource constraint
y_cf = yc*c_cf + yi*i_cf + yg*(y_cf+((1-yg)/yg)*z_g) + ynu*nu_cf + yx_ful*(2*x_ful_cf(-1)+n_ful_cf(-1)) + yx_pat*(2*x_pat_cf(-1)+n_pat_cf(-1)) + yzeta_ful*n_ful_cf(-1);

end;




write_latex_dynamic_model;

@#include "parameter_estimation.mod"



