close all
clear all

set(0,'defaultAxesFontSize',11);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',9.5);
set(0,'defaultTextFontName','Times');

result = dir('*_results.mat');
load(result.name);

filename  = M_.dname;
datafile  = options_.datafile;
paranames = M_.param_names;
endonames = M_.endo_names;
obs_names = options_.varobs;
exo_names = M_.exo_names;
paravalue = M_.params;
sig_value = diag(M_.Sigma_e);
paravalue_str = num2str(paravalue,16);
[nendo nchar_endo]= size(M_.endo_names);
[n_exo nchar_exo]= size(exo_names);
[nobs nchar_obs]= size(obs_names);
if (size(M_.param_names,1) ~=  size(paravalue_str,1))
    error('parameter size is strange')
end
% set parameter values
for i = 1:size(M_.param_names,1)
    eval(cell2mat( (strcat('index_',deblank(M_.param_names(i,:)),'=',num2str(i),';'))));
    eval(cell2mat( strcat(deblank(M_.param_names(i,:)),'=',paravalue_str(i,:),';')));
end
% find estimated parameters among parameters above
index_estparas = estim_params_.param_vals(:,1);
est_para_name_cell = cellstr(M_.param_names(index_estparas,:));
est_para_name_cell_tex = cellstr(M_.param_names_tex(index_estparas,:));

% set indexes for endogenous varibles
set_variables_index;


nirf = options_.irf;
U=triu(ones(nirf,nirf));
shock_name = char(M_.exo_names_long);
val = [dy_obs di_obs dc_obs dw_obs pi_obs u nu rn];
val_ss = {'Output' 'Investment', 'Consumption', 'Capital Utilization','Wage','Unemployment Rate', 'Tightness (FT)', 'Tightness (PT)','Inflation','Marginal Cost', 'Nominal Interest Rate'};
%val_s = cellstr(char(M_.endo_names_long(val,:)));
irf_tec =[(oo_.irfs.dy_obs_e_z*U)' (oo_.irfs.di_obs_e_z*U)' (oo_.irfs.dc_obs_e_z*U)' oo_.irfs.nu_e_z'  (oo_.irfs.dw_obs_e_z*U)'  oo_.irfs.u_e_z'  oo_.irfs.v_ful_e_z'-oo_.irfs.u_ful_e_z'  oo_.irfs.v_pat_e_z'-oo_.irfs.u_pat_e_z'  oo_.irfs.pi_e_z'  oo_.irfs.pw_e_z' oo_.irfs.rn_e_z']; 
irf_ist =[(oo_.irfs.dy_obs_e_i*U)' (oo_.irfs.di_obs_e_i*U)' (oo_.irfs.dc_obs_e_i*U)' oo_.irfs.nu_e_i'  (oo_.irfs.dw_obs_e_i*U)'  oo_.irfs.u_e_i'  oo_.irfs.v_ful_e_i'-oo_.irfs.u_ful_e_i'  oo_.irfs.v_pat_e_i'-oo_.irfs.u_pat_e_i'  oo_.irfs.pi_e_i'  oo_.irfs.pw_e_i' oo_.irfs.rn_e_i']; 

%load('simulation_GST_results.mat')
%irf_tec_GST =[(oo_.irfs.dy_obs_e_z*U)' (oo_.irfs.di_obs_e_z*U)' (oo_.irfs.dc_obs_e_z*U)' oo_.irfs.nu_e_z'  (oo_.irfs.dw_obs_e_z*U)' oo_.irfs.u_e_z']; 

DirectoryName = [ M_.fname '/impulse_other_variables' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);


figure
for i = 1:12
    subplot(4,3,i)
    if i <= 11
        h1=plot(1:nirf,irf_tec(:,i),'-k','linewidth',2); hold on
        %h2=plot(1:nirf,irf_tec_GST(:,i),':r','linewidth',2); 
        h4=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
        title(val_ss(i));
        xticks([10 20 30 40])
        box off
        if (i== 6)
            h1=plot(1:nirf,irf_tec(:,i),'-k','linewidth',2); hold on
            %h2=plot(1:nirf,irf_tec_GST(:,i),':r','linewidth',2); 
            h3=plot(1:nirf,oo_.irfs.uf_e_z',':k','linewidth',1.8);
            h4=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
            title(val_ss(i));
            xticks([10 20 30 40])
            ylim([-3.1 2.2])
            legend([h3],{'Natural Rate'},'location','best');
            legend('boxoff')
            box off
        end
    else
        h1=plot(1:nirf,oo_.irfs.z_z_e_z','-k','linewidth',2); hold on
        h4=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
        title('$\varepsilon_t^z$ Shock','interpreter','latex')
        xticks([10 20 30 40])
        box off
    end     
end
print(['technology_shock.eps'],'-depsc2');

figure
for i = 1:12
    subplot(4,3,i)
    if i <= 11
        h1=plot(1:nirf,irf_ist(:,i),'-k','linewidth',2); hold on
        %h2=plot(1:nirf,irf_tec_GST(:,i),':r','linewidth',2); 
        h4=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
        title(val_ss(i));
        xticks([10 20 30 40])
        box off
        if (i== 6)
            h1=plot(1:nirf,irf_ist(:,i),'-k','linewidth',2); hold on
            %h2=plot(1:nirf,irf_tec_GST(:,i),':r','linewidth',2); 
            h3=plot(1:nirf,oo_.irfs.uf_e_i',':k','linewidth',1.8);
            h4=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
            title(val_ss(i));
            xticks([10 20 30 40])
            ylim([-6.5 3.2])
            legend([h3],{'Natural Rate'},'location','best');
            legend('boxoff')
            box off
        end
    else
        h1=plot(1:nirf,oo_.irfs.z_i_e_i','-k','linewidth',2); hold on
        h3=plot(1:nirf,zeros(1,nirf),'-r','linewidth',0.8);
        title('$\varepsilon_t^i$ Shock','interpreter','latex')
        xticks([10 20 30 40])
        box off
    end     
end
print(['investment_shock.eps'],'-depsc2');


cd(oldFolder);


