clc
close all

result = dir('*_results.mat');
load(result.name);

filename  = M_.dname;
%datafine  = options_.datafile;
paranames = M_.param_names;
paranemes_tex = M_.param_names_tex;
endonames = M_.endo_names;
obs_names = options_.varobs;
exo_names = M_.exo_names;
paravalue = M_.params;
sig_value = diag(M_.Sigma_e);
paravalue_str = num2str(paravalue);
[npara nchar] = size(paranames);
[npara_v nchar_v] = size(paravalue_str);
[nendo nchar_endo]= size(endonames);
[n_exo nchar_exo]= size(exo_names);

index_estparas = estim_params_.param_vals(:,1);

% making the table for reporting estimated parameters
temp = cellstr(paranemes_tex);
temp2 = cellstr(paranames);
temp3 = cellstr(M_.param_names_long);
est_para_str = temp(index_estparas);
est_para_name = temp2(index_estparas);
est_para_long = temp3(index_estparas);
est_exo_str  = cellstr(M_.exo_names_tex);
est_exo_name  = cellstr(M_.exo_names);
est_exo_name_long  = cellstr(M_.exo_names_long);
for i = 1:size(est_para_str,1)
    est_para_str(i) =  cellstr(strcat('$',char(est_para_str(i)),'$'));
end
for j = 1:size(est_exo_str,1)
    est_exo_str(j) =  cellstr(strcat('$',char(est_exo_str(j)),'$'));
end

fid = fopen('para_table.tex','w');

fprintf(fid,'\\begin{table}[t!]\n');
fprintf(fid,'\\caption{ Prior and posterior distributions} \n');
fprintf(fid,'\\resizebox{\\textwidth}{!}{  \n');
%fprintf(fid,'\\scalebox{.8}[.8]{ \n');
fprintf(fid,'\\begin{tabular}{clccccccc}\n');
fprintf(fid,'\\toprule \n');
%fprintf(fid,'\\toprule\n');
fprintf(fid,' & &\\multicolumn{4}{c}{Prior distribution}	&&	\\multicolumn{2}{c}{Posterior distribution} \\\\ \\cmidrule(r){3-6}\\cmidrule(r){8-9}\n');
fprintf(fid,' \\multicolumn{2}{l}{Parameters} & Shape & Support  & Mean & Std. && Mean & 90\\%% interval   \\\\ \\midrule \n');
fprintf(fid,'\\multicolumn{9}{c}{Structural parameters}	\\\\\n');	
for i = 1:size(est_para_str,1)
    if i ==  size(est_para_str,1)- n_exo +1
        fprintf(fid, '\\midrule \n');	
        fprintf(fid, '\\multicolumn{9}{c}{Exogenous processes parameters}  \\\\\n');	
        fprintf(fid, '\\multicolumn{6}{l}{\\textit{Autoregressive coefficient}} &&		& \\\\\n');
    end
    name      = char(est_para_long(i));
    ub = estim_params_.param_vals(i,4);
    lb = estim_params_.param_vals(i,3);
    switch estim_params_.param_vals(i,5)
        case 1
            pshape = 'Beta';
            ub = 1;
            lb = 0;
            bnd = 0;
        case 2
            pshape = 'Gamma';
            bnd = 0;
            if isnan(ub) == 1
                ub = inf;
                bnd = 1;
            end
            if isnan(lb) == 1
                lb = 0;
            end
            if (ub == inf && lb == 0)
                bnd = 3;
            end
        case 3
            pshape = 'Normal';
            bnd = 0;
            if isnan(ub) == 1
                ub = inf;
                bnd = 1;
            end
            if isnan(lb) == 1
                lb = -inf;
                bnd = 2;
            end
            if (ub == inf && lb == 0)
                bnd = 3;
            end
        case 4
            pshape = 'IG';
            ub = inf;
            lb = 0;
            bnd = 1;
        case 5
            pshape = 'Uniform';
            ub = estim_params_.param_vals(i,9);
            lb = estim_params_.param_vals(i,8);
            estim_params_.param_vals(i,6) = (ub+lb)/2;
            estim_params_.param_vals(i,7) = sqrt(((ub-lb)^2)/12);
            bnd = 0;
        case 6
            pshape = 'Inv.~Gamma2';
    end 
    post_mode = eval(strcat('oo_.posterior_mode.parameters.', char(est_para_name(i))));
    post_maan = eval(strcat('oo_.posterior_mean.parameters.', char(est_para_name(i))));
    post_binf = eval(strcat('oo_.posterior_hpdinf.parameters.', char(est_para_name(i))));
    post_bsup = eval(strcat('oo_.posterior_hpdsup.parameters.', char(est_para_name(i))));
    if bnd == 0
        fprintf(fid, ' %-20s & %-40s & %-10s & [%8.1f , %8.1f] & %8.2f & %8.2f && %8.2f & [ %8.2f , %8.2f  ] \\\\ \n', char(est_para_str(i)), name,  pshape,  lb, ub,  estim_params_.param_vals(i,6),  estim_params_.param_vals(i,7), post_maan, post_binf, post_bsup);
    elseif bnd == 1
        fprintf(fid, ' %-20s & %-40s & %-10s & [%8.1f , %8.1f) & %8.2f & %8.2f && %8.2f & [ %8.2f , %8.2f  ] \\\\ \n', char(est_para_str(i)), name,  pshape,  lb, ub,  estim_params_.param_vals(i,6),  estim_params_.param_vals(i,7), post_maan, post_binf, post_bsup);
    elseif bnd == 3
        fprintf(fid,  ' %-20s & %-40s & %-10s &$\\mathbb{R}_{+}$ & %8.2f & %8.2f && %8.2f & [ %8.2f , %8.2f  ]  \\\\ \n', char(est_para_str(i)), name,  pshape,   estim_params_.param_vals(i,6),  estim_params_.param_vals(i,7), post_maan, post_binf, post_bsup);
    else
        fprintf(fid, ' %-20s & %-40s & %-10s & [%8.1f , %8.1f) & %8.2f & %8.2f && %8.2f & ( %8.2f , %8.2f  ] \\\\ \n', char(est_para_str(i)), name,  pshape,  lb, ub,  estim_params_.param_vals(i,6),  estim_params_.param_vals(i,7), post_maan, post_binf, post_bsup);
    end
end
fprintf(fid, '\\multicolumn{6}{l}{\\textit{Standard deviation}} &&		& \\\\ \n');	
for i = 1:n_exo
    %ind = size(est_para_long,1)-n_exo+i;
    %name      = char(est_para_long(ind));
    name      = char(est_exo_name_long(i));
    ub = estim_params_.var_exo(i,4);
    lb = estim_params_.var_exo(i,3);
    switch estim_params_.var_exo(i,5)
        case 1
            pshape = 'Beta';
            ub = 1;
            lb = 0;
            bnd = 0;
        case 2
            pshape = 'Gamma';
            bnd = 0;
            if isnan(ub) == 1
                ub = inf;
                bnd = 1;
            end
            if isnan(lb) == 1
                lb = 0;
            end            
        case 3
            pshape = 'Normal';
            bnd = 0;
            if isnan(ub) == 1
                ub = inf;
                bnd = 1;
            end
            if isnan(lb) == 1
                lb = -inf;
                bnd = 2;
            end 
        case 4
            pshape = 'IG';
            ub = inf;
            lb = 0;
            bnd = 1;
        case 5
            pshape = 'Uniform';
        case 6
            pshape = 'Inv.~Gamma2';
    end
    post_mode = eval(strcat('oo_.posterior_mode.shocks_std.', char(est_exo_name(i))));
    post_maan = eval(strcat('oo_.posterior_mean.shocks_std.', char(est_exo_name(i))));
    post_binf = eval(strcat('oo_.posterior_hpdinf.shocks_std.', char(est_exo_name(i))));
    post_bsup = eval(strcat('oo_.posterior_hpdsup.shocks_std.', char(est_exo_name(i))));  
%    fprintf(fid, ' %-20s & %-40s & %-10s &$\\mathbb{R}_{+}$ & %8.2f & %8.2f && %8.2f & [ %8.2f , %8.2f  ]  \\\\ \n', strrep(char(est_para_str(ind)), '\rho', '\sigma'), name,  pshape, estim_params_.var_exo(i,6), estim_params_.var_exo(i,7), post_maan, post_binf, post_bsup);
    fprintf(fid, ' %-20s & %-40s & %-10s &$\\mathbb{R}_{+}$ & %8.2f & %8.2f && %8.2f & [ %8.2f , %8.2f  ]  \\\\ \n', char(est_exo_str(i)), name,  pshape, estim_params_.var_exo(i,6), estim_params_.var_exo(i,7), post_maan, post_binf, post_bsup);
end
fprintf(fid, '\\bottomrule \n');

fprintf(fid, '\\end{tabular} } \n\n \\raggedright \n \\vspace{3mm}\n');
fprintf(fid, '  \\begin{minilinespace}\n  \\begin{footnotesize}\n'); 
fprintf(fid, '  \\textit{Note}: This table reports the prior and posterior distributions of the estimated parameters.   The Inverse Gamma distribution is denoted by `IG''. The parameters $z_{*}$, $r^{n}_{*}$, and $\\pi_{*}$  respectively denotes $z_{*} = 100\\log{\\gamma_z}$, $r^n_{*} = 100\\log{r^n}$, and $\\pi_{*}=100\\log{\\pi}$. %% With regard to the prior distribution, we report the mean and the standard deviation.  As for posterior distributions, we report the mean and their 90\\%% credible interval. \n'); 
fprintf(fid, '  \\end{footnotesize} \n  \\end{minilinespace} \\label{est_result} \n\\end{table} \n');
%fprintf(fid,'\\cline{2-6}\n');
fopen(fid);