%result = dir('*_results.mat');
%load(result.name);
close all
rho_USdata;

filename  = M_.dname;
datafile  = options_.datafile;
paranames = M_.param_names;
endonames = M_.endo_names;
obs_names = options_.varobs;
exo_names = M_.exo_names;
paravalue = M_.params;
sig_value = diag(M_.Sigma_e);
paravalue_str = num2str(paravalue,16);
[nendo nchar_endo]= size(M_.endo_names);
[n_exo nchar_exo]= size(exo_names);
[nobs nchar_obs]= size(obs_names);
if (size(M_.param_names,1) ~=  size(paravalue_str,1))
    error('parameter size is strange')
end
% set parameter values
for i = 1:size(M_.param_names,1)
    eval(cell2mat( (strcat('index_',deblank(M_.param_names(i,:)),'=',num2str(i),';'))));
    eval(cell2mat( strcat(deblank(M_.param_names(i,:)),'=',paravalue_str(i,:),';')));
end


startDate = datenum('01-01-1979');
startDate2 = datenum('01-01-1996');
endDate = datenum('10-01-2018');
xData = linspace(startDate,endDate,4*(2019-1979));
xData2 = linspace(startDate2,endDate,4*(2019-1996));
% recession
start=[datenum('01-01-1980') datenum('07-01-1981') datenum('07-01-1990') datenum('03-01-2001') datenum('12-01-2007')];
finish=[datenum('07-01-1980') datenum('11-01-1982') datenum('03-01-1991') datenum('11-01-2001') datenum('06-01-2009')];

set(0,'defaultAxesFontSize',11);
set(0,'defaultAxesFontName','Times');
set(0,'defaultTextFontSize',11);
set(0,'defaultTextFontName','Times');

DirectoryName = [ M_.fname '/smoothed_variables' ];
if ~isdir(DirectoryName)
    mkdir('.',DirectoryName);
end
temp = strcat('./',DirectoryName);
oldFolder =  cd(temp);

% smoothed variables
Smooth_mean_rho_ful = oo_.SmoothedVariables.Mean.rho_ful;
Smooth_inf_rho_ful = oo_.SmoothedVariables.HPDinf.rho_ful;
Smooth_sup_rho_ful = oo_.SmoothedVariables.HPDsup.rho_ful;
rhoful=[Smooth_mean_rho_ful Smooth_inf_rho_ful Smooth_sup_rho_ful];



figure
line1=plot(xData(1:end),rhoss_ful+rhoss_ful*(Smooth_mean_rho_ful/100), 'Color',[0.1,0.1,0.1],'LineWidth',2.5); hold on
line2=plot(xData2(1:end),rho_full_data, 'r:','LineWidth',2.0);
y_gridmm = [max(max(rhoss_ful+rhoss_ful*(Smooth_mean_rho_ful/100))) min(min(rhoss_ful+rhoss_ful*(Smooth_mean_rho_ful/100)))];
colorstr=[0.8 0.8 0.8];
yy=[0.87 0.82 0.82 0.87];

for i=1:length(start)
    x=[start(i) start(i) finish(i) finish(i)];
    ps = patch(x,yy,colorstr,'FaceAlpha',0.7,'EdgeColor','none');
    uistack(ps,'bottom')
end
hold off;
set(gca,'XTick',xData)
datetick('x','yyyy')
yticks([0.82 0.83 0.84 0.85 0.86 0.87]);
axis tight
legend([line1 line2],{'Model','US Data'},'Orientation','horizontal','FontSize',12)  %'Position',[.4 .41 .2 0.41]
legend('boxoff')
box off
print(['smoothed_rhoful_level.eps'],'-depsc2');

cd(oldFolder);
